/*===========================================================================
 *
 * File:	DFTexDat.H
 * Author:	Dave Humphrey (uesp@m0use.net)
 * Created On:	Thursday, March 21, 2002
 *
 * Header file for global methods used to load and access Daggerfall texture
 * files.
 *
 *=========================================================================*/
#ifndef __DFTEXDAT_H
#define __DFTEXDAT_H


/*===========================================================================
 *
 * Begin Required Includes
 *
 *=========================================================================*/
  #include "dftexture.h"
/*===========================================================================
 *		End of Required Includes
 *=========================================================================*/


/*===========================================================================
 *
 * Begin Definitions
 *
 *=========================================================================*/



/*===========================================================================
 *		End of Definitions
 *=========================================================================*/


/*===========================================================================
 *
 * Begin Function Definitions
 *
 *=========================================================================*/

	/* Reset all tags on the texture images */
  void ClearDFTextureTags (void);

	/* Called automatically at exit to destroy the DF texture array */
  void DestroyDFTextureArray (void);

	/* Get information on a texture */
  int GetDFTextureWidth  (const int TextureIndex, const int ImageIndex);
  int GetDFTextureHeight (const int TextureIndex, const int ImageIndex);

	/* Attempt to retrieve a texture file or image */
  CDFTextureFile*  GetDFTexture (const int Index);
  CDFTextureImage* GetDFTextureImage (const int TextureIndex, const int ImageIndex);

	/* Called automatically at startup to initialize the DF texture array */
  boolean InitDFTextureArray (void);

	/* Checks to ensure a texture index is valid or not */
  boolean IsLoadedDFTextureIndex (const int Index);

	/* Attempts to load an entire texture file with the given texture index */
  boolean LoadDFTexture (const int Index);


/*===========================================================================
 *		End of Function Definitions
 *=========================================================================*/


#endif
/*===========================================================================
 *		End of File Dftexdat.H
 *=========================================================================*/
