/*===========================================================================
 *
 * File:	Nifalphaproperty.CPP
 * Author:	Dave Humphrey (uesp@m0use.net)
 * Created On:	Monday, December 23, 2002
 *
 * Description
 *
 *=========================================================================*/

	/* Include Files */
#include "stdafx.h"
#include "nifalphaproperty.h"


/*===========================================================================
 *
 * Begin Local Definitions
 *
 *=========================================================================*/
  DEFINE_FILE("NifAlphaProperty.cpp");
/*===========================================================================
 *		End of Local Definitions
 *=========================================================================*/


/*===========================================================================
 *
 * Class CNifAlphaProperty Constructor
 *
 *=========================================================================*/
CNifAlphaProperty::CNifAlphaProperty () {
  //DEFINE_FUNCTION("CNifAlphaProperty::CNifAlphaProperty()");

 }
/*===========================================================================
 *		End of Class CNifAlphaProperty Constructor
 *=========================================================================*/


/*===========================================================================
 *
 * Class CNifAlphaProperty Method - void Destroy (void);
 *
 * Description
 *
 *=========================================================================*/
void CNifAlphaProperty::Destroy (void) {
  //DEFINE_FUNCTION("CNifAlphaProperty::Destroy()");
  CNifBaseRecord::Destroy();
 }
/*===========================================================================
 *		End of Class Method CNifAlphaProperty::Destroy()
 *=========================================================================*/


/*===========================================================================
 *
 * Class CNifAlphaProperty Method - bool Read (FileHandle);
 *
 * Input the node data from the current position in the given file.  Assumes
 * that the current position in the file is the byte after the last character
 * in the "NifNode" name record header.  Returns false on any error.
 *
 *=========================================================================*/
bool CNifAlphaProperty::Read (CGenFile& FileHandle) {
  bool Result;
  
	/* Delete the current record contents */ 
  Destroy();

  	/* Input first three numbers */
  Result = FileHandle.ReadLong(m_Unknown1);
  if (Result) Result = FileHandle.ReadLong(m_Unknown2);
  if (Result) Result = FileHandle.ReadLong(m_Unknown3);
  if (Result) Result = FileHandle.ReadShort(m_Unknown4);
  if (Result) Result = FileHandle.ReadChar(m_Unknown5);
  if (!Result) return (false);

	/* Return success */
  SetIsLoaded(true);
  return (true);
 }
/*===========================================================================
 *		End of Class Method CNifAlphaProperty::Read()
 *=========================================================================*/
  

/*===========================================================================
 *
 * Class CNifAlphaProperty Method - bool Write (FileHandle);
 *
 * Input the node data to the current position in the given file.  Outputs the
 * record header and data.  Returns false on any error.
 *
 *=========================================================================*/
bool CNifAlphaProperty::Write (CGenFile& FileHandle) {
  bool Result;

	/* Call the base class method first */
  Result = CNifBaseRecord::Write(FileHandle);
  if (!Result) return (false);

	/* Output data */
  Result = FileHandle.WriteLong(m_Unknown1);
  if (Result) Result = FileHandle.WriteLong(m_Unknown2);
  if (Result) Result = FileHandle.WriteLong(m_Unknown3);
  if (Result) Result = FileHandle.WriteShort(m_Unknown4);
  if (Result) Result = FileHandle.WriteChar(m_Unknown5);
  if (!Result) return (false);

	/* Return success */
  return (true);
 }
/*===========================================================================
 *		End of Class Method CNifAlphaProperty::Write()
 *=========================================================================*/



