/*===========================================================================
 *
 * File:	NifAmbientLight.H
 * Author:	Dave Humphrey (uesp@m0use.net)
 * Created On:	December 11, 2002
 *
 * Description
 *
 *=========================================================================*/
#ifndef __NIFAMBIENTLIGHT_H
#define __NIFAMBIENTLIGHT_H


/*===========================================================================
 *
 * Begin Required Includes
 *
 *=========================================================================*/
  #include "NifBase.h"
/*===========================================================================
 *		End of Required Includes
 *=========================================================================*/


/*===========================================================================
 *
 * Begin Definitions
 *
 *=========================================================================*/
  #define NIF_AMBLIGHT_NUMFLOATS 30
/*===========================================================================
 *		End of Definitions
 *=========================================================================*/


/*===========================================================================
 *
 * Begin Class CNifAmbientLight Definition
 *
 * Description
 *
 *=========================================================================*/
class CNifAmbientLight : public CNifBaseRecord {

  /*---------- Begin Private Class Members ----------------------*/
private:
  CString	m_LightName;

  long		m_Unknown1;		/* Unknown numbers */
  long		m_Unknown2;	
  short		m_Unknown3;

  float		m_Floats[NIF_AMBLIGHT_NUMFLOATS];



  /*---------- Begin Protected Class Methods --------------------*/
protected:


  /*---------- Begin Public Class Methods -----------------------*/
public:

	/* Class Constructors/Destructors */
  CNifAmbientLight();
  virtual ~CNifAmbientLight() { Destroy(); }
  virtual void Destroy (void);

  	/* Return the optional record name */
  virtual const char*  GetRecordName  (void) const { return (m_LightName); }

	/* Input/Output the section from the current position in the file */
  virtual bool Read  (CGenFile& FileHandle);
  virtual bool Write (CGenFile& FileHandle);

 };
/*===========================================================================
 *		End of Class CNifAmbientLight Definition
 *=========================================================================*/


#endif
/*===========================================================================
 *		End of File Nifmaterialproperty.H
 *=========================================================================*/
