/*===========================================================================
 *
 * File:	NifAutoNormalParticles.CPP
 * Author:	Dave Humphrey (uesp@m0use.net)
 * Created On:	Tuesday, December 24, 2002
 *
 * Description
 *
 *=========================================================================*/

	/* Include Files */
#include "stdafx.h"
#include "NifAutoNormalParticles.h"


/*===========================================================================
 *
 * Begin Local Definitions
 *
 *=========================================================================*/
  DEFINE_FILE("NifAutoNormalParticles.cpp");
/*===========================================================================
 *		End of Local Definitions
 *=========================================================================*/


/*===========================================================================
 *
 * Class CNifAutoNormalParticles Constructor
 *
 *=========================================================================*/
CNifAutoNormalParticles::CNifAutoNormalParticles () {
  //DEFINE_FUNCTION("CNifAutoNormalParticles::CNifAutoNormalParticles()");
  
 }
/*===========================================================================
 *		End of Class CNifAutoNormalParticles Constructor
 *=========================================================================*/


/*===========================================================================
 *
 * Class CNifAutoNormalParticles Method - void Destroy (void);
 *
 *=========================================================================*/
void CNifAutoNormalParticles::Destroy (void) {
  //DEFINE_FUNCTION("CNifAutoNormalParticles::Destroy()");

  CNifBaseRecord::Destroy();
 }
/*===========================================================================
 *		End of Class Method CNifAutoNormalParticles::Destroy()
 *=========================================================================*/


/*===========================================================================
 *
 * Class CNifAutoNormalParticles Method - bool Read (FileHandle);
 *
 *=========================================================================*/
bool CNifAutoNormalParticles::Read (CGenFile& FileHandle) {
  //DEFINE_FUNCTION("CNifAutoNormalParticles::Read()");
  bool Result;

  Destroy();

  Result = NifReadString(FileHandle, m_ParticleName);
  if (Result) Result = FileHandle.ReadLong(m_Unknown1);
  if (Result) Result = FileHandle.ReadLong(m_Unknown2);
  if (Result) Result = FileHandle.ReadLong(m_Unknown3);
  if (Result) Result = FileHandle.ReadShort(m_Unknown4);
  if (Result) Result = FileHandle.Read((char *)&m_Floats[0], sizeof(float)*NIF_ANPART_NUMFLOATS);
  if (Result) Result = m_LongArray.Read(FileHandle);
  if (Result) Result = FileHandle.Read((char *)&m_Values[0], sizeof(long)*NIF_ANPART_NUMLONGS);
  if (!Result) return (false);

  SetIsLoaded(true);
  return (true);
 }
/*===========================================================================
 *		End of Class Method CNifAutoNormalParticles::Read()
 *=========================================================================*/


/*===========================================================================
 *
 * Class CNifAutoNormalParticles Method - bool Read (FileHandle);
 *
 *=========================================================================*/
bool CNifAutoNormalParticles::Write (CGenFile& FileHandle) {
  //DEFINE_FUNCTION("CNifAutoNormalParticles::Write()");
  bool Result;

	/* Call the base class record method */
  Result = CNifBaseRecord::Write(FileHandle);
  if (!Result) return (false);

  Result = NifWriteString(FileHandle, m_ParticleName);
  if (Result) Result = FileHandle.WriteLong(m_Unknown1);
  if (Result) Result = FileHandle.WriteLong(m_Unknown2);
  if (Result) Result = FileHandle.WriteLong(m_Unknown3);
  if (Result) Result = FileHandle.WriteShort(m_Unknown4);
  if (Result) Result = FileHandle.Write((char *)&m_Floats[0], sizeof(float)*NIF_ANPART_NUMFLOATS);
  if (Result) Result = m_LongArray.Write(FileHandle);
  if (Result) Result = FileHandle.Write((char *)&m_Values[0], sizeof(long)*NIF_ANPART_NUMLONGS);
  if (!Result) return (false);

  return (true);
 }
/*===========================================================================
 *		End of Class Method CNifAutoNormalParticles::Write()
 *=========================================================================*/