/*===========================================================================
 *
 * File:	NifAutoNormalParticles.H
 * Author:	Dave Humphrey (uesp@m0use.net)
 * Created On:	Tuesday, December 24, 2002
 *
 * Description
 *
 *=========================================================================*/
#ifndef __NIFAUTONORMALPARTICLES_H
#define __NIFAUTONORMALPARTICLES_H


/*===========================================================================
 *
 * Begin Required Includes
 *
 *=========================================================================*/
  #include "NifBase.h"
  #include "NifLongArray.h"
/*===========================================================================
 *		End of Required Includes
 *=========================================================================*/


/*===========================================================================
 *
 * Begin Definitions
 *
 *=========================================================================*/
  #define NIF_ANPART_NUMFLOATS 15
  #define NIF_ANPART_NUMLONGS   3
/*===========================================================================
 *		End of Definitions
 *=========================================================================*/


/*===========================================================================
 *
 * Begin Class CNifAutoNormalParticles Definition
 *
 * Description
 *
 *=========================================================================*/
class CNifAutoNormalParticles : public CNifBaseRecord {

  /*---------- Begin Private Class Members ----------------------*/
private:
  CString	m_ParticleName;
  long		m_Unknown1;
  long		m_Unknown2;
  long		m_Unknown3;
  short		m_Unknown4;
  float		m_Floats[NIF_ANPART_NUMFLOATS];
  CNifLongArray	m_LongArray;
  long		m_Values[NIF_ANPART_NUMLONGS];


  /*---------- Begin Protected Class Methods --------------------*/
protected:


  /*---------- Begin Public Class Methods -----------------------*/
public:

	/* Class Constructors/Destructors */
  CNifAutoNormalParticles();
  virtual ~CNifAutoNormalParticles() { Destroy(); }
  virtual void Destroy (void);

  virtual const char*  GetRecordName  (void) const { return (m_ParticleName); }

	/* Input/Output the section from the current position in the file */
  virtual bool Read  (CGenFile& FileHandle);
  virtual bool Write (CGenFile& FileHandle);

 };
/*===========================================================================
 *		End of Class CNifAutoNormalParticles Definition
 *=========================================================================*/


#endif
/*===========================================================================
 *		End of File NifRotatingParticles.H
 *=========================================================================*/
