/*===========================================================================
 *
 * File:	NifAutoNormalParticlesData.H
 * Author:	Dave Humphrey (uesp@m0use.net)
 * Created On:	Tuesday, December 24, 2002
 *
 * Description
 *
 *=========================================================================*/
#ifndef __NIFAUTONORMALPARTICLESDATA_H
#define __NIFAUTONORMALPARTICLESDATA_H


/*===========================================================================
 *
 * Begin Required Includes
 *
 *=========================================================================*/
  #include "NifBase.h"
/*===========================================================================
 *		End of Required Includes
 *=========================================================================*/


/*===========================================================================
 *
 * Begin Definitions
 *
 *=========================================================================*/
  #define NIF_ANPD_NUMFLOATS1 3
  #define NIF_ANPD_NUMFLOATS2 4
  #define NIF_ANPD_NUMFLOATS3 4
  #define NIF_ANPD_NUMFLOATS4 1
/*===========================================================================
 *		End of Definitions
 *=========================================================================*/


/*===========================================================================
 *
 * Begin Class CNifAutoNormalParticlesData Definition
 *
 * Description
 *
 *=========================================================================*/
class CNifAutoNormalParticlesData : public CNifBaseRecord {

  /*---------- Begin Private Class Members ----------------------*/
private:
  short		m_NumValues1;
  float		m_Unknown1;
  float*	m_pValues1;
  float*	m_pValues1a;
  long		m_Unknown2;
  nifpos4_t	m_Values2;
  short		m_Unknown3;
  short		m_Unknown4;
  float*	m_pValues3;
  long		m_Unknown5;
  short		m_Unknown6;
  short		m_Unknown7;
  float		m_Unknown8;
  short		m_Unknown9;
  short		m_Unknown10;
  short		m_Unknown11;
  float*	m_pValues4;


  /*---------- Begin Protected Class Methods --------------------*/
protected:


  /*---------- Begin Public Class Methods -----------------------*/
public:

	/* Class Constructors/Destructors */
  CNifAutoNormalParticlesData();
  virtual ~CNifAutoNormalParticlesData() { Destroy(); }
  virtual void Destroy (void);

	/* Input/Output the section from the current position in the file */
  virtual bool Read  (CGenFile& FileHandle);
  virtual bool Write (CGenFile& FileHandle);

 };
/*===========================================================================
 *		End of Class CNifAutoNormalParticlesData Definition
 *=========================================================================*/


#endif
/*===========================================================================
 *		End of File NifAutoNormalParticlesData.H
 *=========================================================================*/
