/*===========================================================================
 *
 * File:	NifBSPArrayController.H
 * Author:	Dave Humphrey (uesp@m0use.net)
 * Created On:	Tuesday, December 24, 2002
 *
 * Description
 *
 *=========================================================================*/
#ifndef __NIFBSPARRAYCONTROLLER_H
#define __NIFBSPARRAYCONTROLLER_H


/*===========================================================================
 *
 * Begin Required Includes
 *
 *=========================================================================*/
  #include "NifBase.h"
/*===========================================================================
 *		End of Required Includes
 *=========================================================================*/


/*===========================================================================
 *
 * Begin Definitions
 *
 *=========================================================================*/
  #define NIF_BSPACRECORD_NUMFLOATS 9
  #define NIF_BSPAC_NUMFLOATS1 16
  #define NIF_BSPAC_NUMFLOATS2 5
  #define NIF_BSPAC_NUMFLOATS3 9
/*===========================================================================
 *		End of Definitions
 *=========================================================================*/


/*===========================================================================
 *
 * Begin Type Definitions
 *
 *=========================================================================*/


  typedef struct {
    float Data[NIF_BSPACRECORD_NUMFLOATS];
   } nifbspacrecord_t;

/*===========================================================================
 *		End of Type Definitions
 *=========================================================================*/


/*===========================================================================
 *
 * Begin Class CNifBSPACRecord Definition
 *
 * Description
 *
 *=========================================================================*/
class CNifBSPACRecord {

  /*---------- Begin Private Class Members ----------------------*/
private:
  short			m_Unknown1;
  short			m_Index;
  nifbspacrecord_t	m_Data;


  /*---------- Begin Protected Class Methods --------------------*/
protected:


  /*---------- Begin Public Class Methods -----------------------*/
public:

	/* Class Constructors/Destructors */
  CNifBSPACRecord() { }
  virtual ~CNifBSPACRecord() { Destroy(); }
  virtual void Destroy (void) { }

  bool IsLastRecord (void) const { return (m_Unknown1 != 0); }

	/* Input/Output the section from the current position in the file */
  virtual bool Read  (CGenFile& FileHandle);
  virtual bool Write (CGenFile& FileHandle);


 };
/*===========================================================================
 *		End of Class CNifBSPACRecord Definition
 *=========================================================================*/


/*===========================================================================
 *
 * Begin Class CNifBSPArrayController Definition
 *
 * Description
 *
 *=========================================================================*/
class CNifBSPArrayController : public CNifBaseRecord {

  /*---------- Begin Private Class Members ----------------------*/
private:
  long		m_Unknown1;
  short		m_Unknown2;
  nifpos4_t	m_Position1;
  long		m_Unknown3;
  float		m_Floats1[NIF_BSPAC_NUMFLOATS1];
  char		m_Unknown4;
  nifpos_t	m_Position2;
  long		m_Unknown5;
  float		m_Floats2[NIF_BSPAC_NUMFLOATS2];
  long		m_Unknown6;
  long		m_Unknown7;
  short		m_Unknown8;
  short		m_NumRecords1;
  short		m_NumRecords2;

  CNifBSPACRecord*	m_pRecords;

  long		m_Unknown9;
  long		m_Unknown10;
  long		m_Unknown11;
  char		m_Unknown12;


  /*---------- Begin Protected Class Methods --------------------*/
protected:


  /*---------- Begin Public Class Methods -----------------------*/
public:

	/* Class Constructors/Destructors */
  CNifBSPArrayController();
  virtual ~CNifBSPArrayController() { Destroy(); }
  virtual void Destroy (void);

  int GetNumRecords (void) const { return (m_NumRecords1); }

	/* Input/Output the section from the current position in the file */
  virtual bool Read  (CGenFile& FileHandle);
  virtual bool Write (CGenFile& FileHandle);

 };
/*===========================================================================
 *		End of Class CNifBSPArrayController Definition
 *=========================================================================*/


#endif
/*===========================================================================
 *		End of File NifParticleSysController.H
 *=========================================================================*/
