/*===========================================================================
 *
 * File:	NifBillboardNode.H
 * Author:	Dave Humphrey (uesp@m0use.net)
 * Created On:	December 11, 2002
 *
 * Description
 *
 *=========================================================================*/
#ifndef __NIFBILLBOARDNODE_H
#define __NIFBILLBOARDNODE_H


/*===========================================================================
 *
 * Begin Required Includes
 *
 *=========================================================================*/
  #include "NifBase.h"
  #include "NifLongArray.h"
/*===========================================================================
 *		End of Required Includes
 *=========================================================================*/


/*===========================================================================
 *
 * Begin Definitions
 *
 *=========================================================================*/
  #define NIF_BILLBOARDNODE_NUMVALUES 16
/*===========================================================================
 *		End of Definitions
 *=========================================================================*/


/*===========================================================================
 *
 * Begin Class CNifBillboardNode Definition
 *
 * Description
 *
 *=========================================================================*/
class CNifBillboardNode : public CNifBaseRecord {

  /*---------- Begin Private Class Members ----------------------*/
private:
  CString	m_NodeName;

  long		m_Unknown1;
  long		m_Unknown2;
  short		m_Unknown3;

  float		m_Values[NIF_BILLBOARDNODE_NUMVALUES];

  CNifLongArray m_Array1;
  CNifLongArray m_Array2;
  CNifLongArray m_Array3;
  CNifLongArray m_Array4;



  /*---------- Begin Protected Class Methods --------------------*/
protected:


  /*---------- Begin Public Class Methods -----------------------*/
public:

	/* Class Constructors/Destructors */
  CNifBillboardNode();
  virtual ~CNifBillboardNode() { Destroy(); }
  virtual void Destroy (void);

	/* Return the optional record name */
  virtual const char*  GetRecordName  (void) const { return (m_NodeName); }

	/* Input/Output the section from the current position in the file */
  virtual bool Read  (CGenFile& FileHandle);
  virtual bool Write (CGenFile& FileHandle);


 };
/*===========================================================================
 *		End of Class CNifBillboardNode Definition
 *=========================================================================*/


#endif
/*===========================================================================
 *		End of File Nifparticlenode.H
 *=========================================================================*/
