/*===========================================================================
 *
 * File:	NifCamera.H
 * Author:	Dave Humphrey (uesp@m0use.net)
 * Created On:	Tuesday, December 24, 2002
 *
 * Description
 *
 *=========================================================================*/
#ifndef __NIFCAMERA_H
#define __NIFCAMERA_H


/*===========================================================================
 *
 * Begin Required Includes
 *
 *=========================================================================*/
  #include "NifBase.h"
/*===========================================================================
 *		End of Required Includes
 *=========================================================================*/


/*===========================================================================
 *
 * Begin Definitions
 *
 *=========================================================================*/
  #define NIF_CAMERA_NUMFLOATS 29
/*===========================================================================
 *		End of Definitions
 *=========================================================================*/



/*===========================================================================
 *
 * Begin Type Definitions
 *
 *=========================================================================*/
#pragma pack(push, 1)

#pragma pack(pop)
/*===========================================================================
 *		End of Type Definitions
 *=========================================================================*/


/*===========================================================================
 *
 * Begin Class CNifCamera Definition
 *
 * Description
 *
 *=========================================================================*/
class CNifCamera : public CNifBaseRecord {

  /*---------- Begin Private Class Members ----------------------*/
private:
  CString	m_CameraName;
  long		m_Unknown1;
  long		m_Unknown2;
  short		m_Unknown3;
  float		m_Floats[NIF_CAMERA_NUMFLOATS];
  long		m_Unknown4;
  long		m_Unknown5;


  /*---------- Begin Protected Class Methods --------------------*/
protected:


  /*---------- Begin Public Class Methods -----------------------*/
public:

	/* Class Constructors/Destructors */
  CNifCamera();
  virtual ~CNifCamera() { Destroy(); }
  virtual void Destroy (void);

  	/* Return the optional record name */
  virtual const char*  GetRecordName  (void) const { return (m_CameraName); }

	/* Input/Output the section from the current position in the file */
  virtual bool Read  (CGenFile& FileHandle);
  virtual bool Write (CGenFile& FileHandle);

 };
/*===========================================================================
 *		End of Class CNifCamera Definition
 *=========================================================================*/


#endif
/*===========================================================================
 *		End of File NifVisData.H
 *=========================================================================*/
