/*===========================================================================
 *
 * File:	NifColorData.CPP
 * Author:	Dave Humphrey (uesp@m0use.net)
 * Created On:	Tuesday, December 24, 2002
 *
 * Description
 *
 *=========================================================================*/

	/* Include Files */
#include "stdafx.h"
#include "NifColorData.h"


/*===========================================================================
 *
 * Begin Local Definitions
 *
 *=========================================================================*/
  DEFINE_FILE("NifColorData.cpp");
/*===========================================================================
 *		End of Local Definitions
 *=========================================================================*/


/*===========================================================================
 *
 * Class CNifColorData Constructor
 *
 *=========================================================================*/
CNifColorData::CNifColorData () {
  //DEFINE_FUNCTION("CNifColorData::CNifColorData()");
 
 }
/*===========================================================================
 *		End of Class CNifColorData Constructor
 *=========================================================================*/


/*===========================================================================
 *
 * Class CNifColorData Method - void Destroy (void);
 *
 *=========================================================================*/
void CNifColorData::Destroy (void) {
  //DEFINE_FUNCTION("CNifColorData::Destroy()");
 
  CNifBaseRecord::Destroy();
 }
/*===========================================================================
 *		End of Class Method CNifColorData::Destroy()
 *=========================================================================*/


/*===========================================================================
 *
 * Class CNifColorData Method - bool Read (FileHandle);
 *
 *=========================================================================*/
bool CNifColorData::Read (CGenFile& FileHandle) {
  DEFINE_FUNCTION("CNifColorData::Read()");
  bool Result;

  Destroy();

  Result = FileHandle.ReadLong(m_Unknown1);
  if (Result) Result = FileHandle.ReadLong(m_Unknown2);
  if (Result) Result = FileHandle.Read((char *)&m_Floats[0], sizeof(float)*NIF_COLORDATA_NUMFLOATS);
  if (!Result) return (false);

  SetIsLoaded(true);
  return (true);
 }
/*===========================================================================
 *		End of Class Method CNifColorData::Read()
 *=========================================================================*/


/*===========================================================================
 *
 * Class CNifColorData Method - bool Read (FileHandle);
 *
 *=========================================================================*/
bool CNifColorData::Write (CGenFile& FileHandle) {
  //DEFINE_FUNCTION("CNifColorData::Write()");
  bool Result;

	/* Call the base class record method */
  Result = CNifBaseRecord::Write(FileHandle);
  if (!Result) return (false);

  Result = FileHandle.WriteLong(m_Unknown1);
  if (Result) Result = FileHandle.WriteLong(m_Unknown2);
  if (Result) Result = FileHandle.Write((char *)&m_Floats[0], sizeof(float)*NIF_COLORDATA_NUMFLOATS);
  if (!Result) return (false);

  return (true);
 }
/*===========================================================================
 *		End of Class Method CNifColorData::Write()
 *=========================================================================*/