/*===========================================================================
 *
 * File:	NifEOF.CPP
 * Author:	Dave Humphrey (uesp@m0use.net)
 * Created On:	Tuesday, December 24, 2002
 *
 * Description
 *
 *=========================================================================*/

	/* Include Files */
#include "stdafx.h"
#include "NifEOF.h"


/*===========================================================================
 *
 * Begin Local Definitions
 *
 *=========================================================================*/
  DEFINE_FILE("NifEOF.cpp");
/*===========================================================================
 *		End of Local Definitions
 *=========================================================================*/


/*===========================================================================
 *
 * Class CNifEOF Constructor
 *
 *=========================================================================*/
CNifEOF::CNifEOF () {
  //DEFINE_FUNCTION("CNifEOF::CNifEOF()");
  m_DataSize = 0;
  m_pData    = NULL;
 }
/*===========================================================================
 *		End of Class CNifEOF Constructor
 *=========================================================================*/


/*===========================================================================
 *
 * Class CNifEOF Method - void Destroy (void);
 *
 *=========================================================================*/
void CNifEOF::Destroy (void) {
  DEFINE_FUNCTION("CNifEOF::Destroy()");

  m_DataSize = 0;
  DestroyArrayPointer(m_pData);
 
  CNifBaseRecord::Destroy();
 }
/*===========================================================================
 *		End of Class Method CNifEOF::Destroy()
 *=========================================================================*/


/*===========================================================================
 *
 * Class CNifEOF Method - bool Read (FileHandle);
 *
 *=========================================================================*/
bool CNifEOF::Read (CGenFile& FileHandle) {
  DEFINE_FUNCTION("CNifEOF::Read()");
  bool Result;

  Destroy();

	/* Get the size of the buffer */
  m_DataSize = FileHandle.GetFileSize() - FileHandle.Tell();

	/* Ensure a valid record size */
  if (m_DataSize < 0) {
    ErrorHandler.AddError(ERR_BADINPUT, _T("Received an invalid record size of %d!"), m_DataSize);
    return (false);
   }
  else if (m_DataSize == 0) {
    return (true);
   }

	/* Allocate and read the data block */
  CreateArrayPointer(m_pData, char, m_DataSize);
  Result = FileHandle.Read(m_pData, m_DataSize);
  if (!Result) return (false);

  SetIsLoaded(true);
  return (true);
 }
/*===========================================================================
 *		End of Class Method CNifEOF::Read()
 *=========================================================================*/


/*===========================================================================
 *
 * Class CNifEOF Method - bool Read (FileHandle);
 *
 *=========================================================================*/
bool CNifEOF::Write (CGenFile& FileHandle) {
  //DEFINE_FUNCTION("CNifEOF::Write()");
  bool Result;

	/* Call the base class record method */
  Result = CNifBaseRecord::Write(FileHandle);
  if (!Result) return (false);

	/* Output the data block if required */
  if (m_DataSize > 0) {
    Result = FileHandle.Write(m_pData, m_DataSize);
    if (!Result) return (false);
   }

  return (true);
 }
/*===========================================================================
 *		End of Class Method CNifEOF::Write()
 *=========================================================================*/