/*===========================================================================
 *
 * File:	NifGeomMorpherController.CPP
 * Author:	Dave Humphrey (uesp@m0use.net)
 * Created On:	Monday, December 23, 2002
 *
 * Description
 *
 *=========================================================================*/

	/* Include Files */
#include "stdafx.h"
#include "NifGeomMorpherController.h"


/*===========================================================================
 *
 * Begin Local Definitions
 *
 *=========================================================================*/
  DEFINE_FILE("NifGeomMorpherController.cpp");
/*===========================================================================
 *		End of Local Definitions
 *=========================================================================*/


/*===========================================================================
 *
 * Class CNifGeomMorpherController Constructor
 *
 *=========================================================================*/
CNifGeomMorpherController::CNifGeomMorpherController () {
  //DEFINE_FUNCTION("CNifGeomMorpherController::CNifGeomMorpherController()");
 
 }
/*===========================================================================
 *		End of Class CNifGeomMorpherController Constructor
 *=========================================================================*/


/*===========================================================================
 *
 * Class CNifGeomMorpherController Method - void Destroy (void);
 *
 *=========================================================================*/
void CNifGeomMorpherController::Destroy (void) {
  //DEFINE_FUNCTION("CNifGeomMorpherController::Destroy()");
  CNifBaseRecord::Destroy();
 }
/*===========================================================================
 *		End of Class Method CNifGeomMorpherController::Destroy()
 *=========================================================================*/


/*===========================================================================
 *
 * Class CNifGeomMorpherController Method - bool Read (FileHandle);
 *
 * Input the node data from the current position in the given file.  Assumes
 * that the current position in the file is the byte after the last character
 * in the "NifNode" name record header.  Returns false on any error.
 *
 *=========================================================================*/
bool CNifGeomMorpherController::Read (CGenFile& FileHandle) {
  bool Result;
  
	/* Delete the current record contents */ 
  Destroy();
  
  Result = FileHandle.ReadLong(m_Unknown1);
  if (Result) Result = FileHandle.ReadShort(m_Unknown2);
  if (Result) Result = FileHandle.Read((char *)&m_Position, sizeof(nifpos4_t));
  if (Result) Result = FileHandle.ReadLong(m_Unknown3);
  if (Result) Result = FileHandle.ReadLong(m_Unknown4);
  if (Result) Result = FileHandle.ReadChar(m_Unknown5);
  if (!Result) return (false);

	/* Return success */
  SetIsLoaded(true);
  return (true);
 }
/*===========================================================================
 *		End of Class Method CNifGeomMorpherController::Read()
 *=========================================================================*/
  

/*===========================================================================
 *
 * Class CNifGeomMorpherController Method - bool Write (FileHandle);
 *
 * Input the node data to the current position in the given file.  Outputs the
 * record header and data.  Returns false on any error.
 *
 *=========================================================================*/
bool CNifGeomMorpherController::Write (CGenFile& FileHandle) {
  bool Result;

	/* Call the base class method first */
  Result = CNifBaseRecord::Write(FileHandle);
  if (!Result) return (false);

  Result = FileHandle.WriteLong(m_Unknown1);
  if (Result) Result = FileHandle.WriteShort(m_Unknown2);
  if (Result) Result = FileHandle.Write((char *)&m_Position, sizeof(nifpos4_t));
  if (Result) Result = FileHandle.WriteLong(m_Unknown3);
  if (Result) Result = FileHandle.WriteLong(m_Unknown4);
  if (Result) Result = FileHandle.WriteChar(m_Unknown5);
  if (!Result) return (false);

	/* Return success */
  return (true);
 }
/*===========================================================================
 *		End of Class Method CNifGeomMorpherController::Write()
 *=========================================================================*/



 