/*===========================================================================
 *
 * File:	NifKeyFrameController.H
 * Author:	Dave Humphrey (uesp@m0use.net)
 * Created On:	Monday, December 23, 2002
 *
 * Description
 *
 *=========================================================================*/
#ifndef __NIFKEYFRAMECONTROLLER_H
#define __NIFKEYFRAMECONTROLLER_H


/*===========================================================================
 *
 * Begin Required Includes
 *
 *=========================================================================*/
  #include "NifBase.h"
/*===========================================================================
 *		End of Required Includes
 *=========================================================================*/


/*===========================================================================
 *
 * Begin Class CNifKeyFrameController Definition
 *
 * Description
 *
 *=========================================================================*/
class CNifKeyFrameController : public CNifBaseRecord {

  /*---------- Begin Private Class Members ----------------------*/
private:
  long		m_Unknown1;
  short		m_Unknown2;
  nifpos4_t	m_Position;
  long		m_Unknown3;
  long		m_Unknown4;


  /*---------- Begin Protected Class Methods --------------------*/
protected:


  /*---------- Begin Public Class Methods -----------------------*/
public:

	/* Class Constructors/Destructors */
  CNifKeyFrameController();
  virtual ~CNifKeyFrameController() { Destroy(); }
  virtual void Destroy (void);

	/* Get class members */
  float      GetStartTime     (void) { return (m_Position.Z); }
  float      GetEndTime       (void) { return (m_Position.W); }
  long	     GetKeyFrameIndex (void) { return (m_Unknown4); }
  nifpos4_t& GetPosition      (void) { return (m_Position); }
 
	/* Input/Output the section from the current position in the file */
  virtual bool Read  (CGenFile& FileHandle);
  virtual bool Write (CGenFile& FileHandle);

 };
/*===========================================================================
 *		End of Class CNifKeyFrameController Definition
 *=========================================================================*/


#endif
/*===========================================================================
 *		End of File NifKeyFrameController.H
 *=========================================================================*/
