/*===========================================================================
 *
 * File:	Niflongarray.CPP
 * Author:	Dave Humphrey (uesp@m0use.net)
 * Created On:	Monday, December 23, 2002
 *
 * Description
 *
 *=========================================================================*/

	/* Include Files */
#include "stdafx.h"
#include "niflongarray.h"


/*===========================================================================
 *
 * Begin Required Includes
 *
 *=========================================================================*/
  DEFINE_FILE("NifLongArray.cpp");
/*===========================================================================
 *		End of Required Includes
 *=========================================================================*/


/*===========================================================================
 *
 * Class CNifLongArray Constructor
 *
 *=========================================================================*/
CNifLongArray::CNifLongArray () {
  //DEFINE_FUNCTION("CNifLongArray::CNifLongArray()");
 m_Size = 0;
 m_AllocatedSize = 0;
 m_pData = NULL;
 }
/*===========================================================================
 *		End of Class CNifLongArray Constructor
 *=========================================================================*/


/*===========================================================================
 *
 * Class CNifLongArray Method - void Destroy (void);
 *
 * Description
 *
 *=========================================================================*/
void CNifLongArray::Destroy (void) {
  DEFINE_FUNCTION("CNifLongArray::Destroy()");

  DestroyArrayPointer(m_pData);
  m_Size = 0;
  m_AllocatedSize = 0;
 }
/*===========================================================================
 *		End of Class Method CNifLongArray::Destroy()
 *=========================================================================*/


/*===========================================================================
 *
 * Class CNifLongArray Method - bool Read (CGenFile& FileHandle);
 *
 * Description
 *
 *=========================================================================*/
bool CNifLongArray::Read (CGenFile& FileHandle) {
  DEFINE_FUNCTION("CNifLongArray::Read()");
  bool Result;

  Destroy();

	/* Input the long array size value */
  Result = FileHandle.ReadLong(m_Size);
  if (!Result) return (false);

	/* Ensure a valid input size */
  if (m_Size < 0) {
    ErrorHandler.AddError(ERR_CUSTOM, "Invalid array size input (%ld)!", m_Size);
    return (false);
   }

  if (m_Size == 0) {
    m_AllocatedSize = 0;
    return (true);
   }

	/* Allocate the array */
  CreateArrayPointer(m_pData, long, m_Size);
  m_AllocatedSize = m_Size;

	/* Input the array */
  Result = FileHandle.Read((char *)m_pData, sizeof(long)*m_Size);
  return (Result);
 }
/*===========================================================================
 *		End of Class Method CNifLongArray::Read()
 *=========================================================================*/


/*===========================================================================
 *
 * Class CNifLongArray Method - bool Write (CGenFile& FileHandle);
 *
 * Description
 *
 *=========================================================================*/
bool CNifLongArray::Write (CGenFile& FileHandle) {
  DEFINE_FUNCTION("CNifLongArray::Write()");
  bool Result;

	/* Output the long array size value */
  Result = FileHandle.WriteLong(m_Size);
  if (!Result) return (false);

	/* Ensure a valid input size */
  if (m_Size <= 0 || m_pData == NULL) return (true);

  Result = FileHandle.Write((char *)m_pData, sizeof(long)*m_Size);
  return (Result);
 }
/*===========================================================================
 *		End of Class Method CNifLongArray::Write()
 *=========================================================================*/
