/*===========================================================================
 *
 * File:	Niflongarray.H
 * Author:	Dave Humphrey (uesp@m0use.net)
 * Created On:	Monday, December 23, 2002
 *
 * Description
 *
 *=========================================================================*/
#ifndef __NIFLONGARRAY_H
#define __NIFLONGARRAY_H


/*===========================================================================
 *
 * Begin Required Includes
 *
 *=========================================================================*/
  #include "NifBase.h"
/*===========================================================================
 *		End of Required Includes
 *=========================================================================*/


/*===========================================================================
 *
 * Begin Class CNifLongArray Definition
 *
 * Description
 *
 *=========================================================================*/
class CNifLongArray {

  /*---------- Begin Private Class Members ----------------------*/
private:
  long	m_Size;
  long* m_pData;
  long  m_AllocatedSize;


  /*---------- Begin Protected Class Methods --------------------*/
protected:


  /*---------- Begin Public Class Methods -----------------------*/
public:

	/* Class Constructors/Destructors */
  CNifLongArray();
  virtual ~CNifLongArray() { Destroy(); }
  virtual void Destroy (void);

	/* Get class members */
  long GetSize          (void) const { return (m_Size); }
  long GetAllocatedSize (void) const { return (m_AllocatedSize); }
  long GetAt		(const int Index) const { return (IsValidIndex(Index) ? m_pData[Index] : -1); }
  bool IsValidIndex	(const int Index) const { return (Index >= 0 && Index < m_Size); }

	/* Input/Output the section from the current position in the file */
  virtual bool Read  (CGenFile& FileHandle);
  virtual bool Write (CGenFile& FileHandle);


 };
/*===========================================================================
 *		End of Class CNifLongArray Definition
 *=========================================================================*/


#endif
/*===========================================================================
 *		End of File Niflongarray.H
 *=========================================================================*/
