/*===========================================================================
 *
 * File:	NifParticleRotation.CPP
 * Author:	Dave Humphrey (uesp@m0use.net)
 * Created On:	December 11, 2002
 *
 * Description
 *
 *=========================================================================*/

	/* Include Files */
#include "stdafx.h"
#include "NifParticleRotation.h"


/*===========================================================================
 *
 * Begin Local Definitions
 *
 *=========================================================================*/
  DEFINE_FILE("NifParticleRotation.cpp");
/*===========================================================================
 *		End of Local Definitions
 *=========================================================================*/


/*===========================================================================
 *
 * Class CNifParticleRotation Constructor
 *
 *=========================================================================*/
CNifParticleRotation::CNifParticleRotation () {
  //DEFINE_FUNCTION("CNifParticleRotation::CNifParticleRotation()");

 }
/*===========================================================================
 *		End of Class CNifParticleRotation Constructor
 *=========================================================================*/


/*===========================================================================
 *
 * Class CNifParticleRotation Method - void Destroy (void);
 *
 *=========================================================================*/
void CNifParticleRotation::Destroy (void) {
  DEFINE_FUNCTION("CNifParticleRotation::Destroy()");

	/* Call the base class method */
  CNifBaseRecord::Destroy();
 }
/*===========================================================================
 *		End of Class Method CNifParticleRotation::Destroy()
 *=========================================================================*/


/*===========================================================================
 *
 * Class CNifParticleRotation Method - bool Read (FileHandle);
 *
 * Input the node data from the current position in the given file.  Assumes
 * that the current position in the file is the byte after the last character
 * in the "NifNode" name record header.  Returns false on any error.
 *
 *=========================================================================*/
bool CNifParticleRotation::Read (CGenFile& FileHandle) {
  bool Result;

	/* Delete the current record contents */
  Destroy();

  	/* Input first three numbers */
  Result = FileHandle.ReadLong(m_Unknown1);
  if (Result) Result = FileHandle.ReadLong(m_Unknown2);
  if (Result) Result = FileHandle.ReadChar(m_Unknown3);
  if (!Result) return (false);

	/* Input values array */
  Result = FileHandle.Read((char *)&m_Values[0], sizeof(float)*NIF_PARTROT_NUMVALUES);
  if (!Result) return (false);

	/* Return success */
  SetIsLoaded(true);
  return (true);
 }
/*===========================================================================
 *		End of Class Method CNifParticleRotation::Read()
 *=========================================================================*/
  

/*===========================================================================
 *
 * Class CNifParticleRotation Method - bool Write (FileHandle);
 *
 * Input the node data to the current position in the given file.  Outputs the
 * record header and data.  Returns false on any error.
 *
 *=========================================================================*/
bool CNifParticleRotation::Write (CGenFile& FileHandle) {
  bool Result;

	/* Call the base class method first */
  Result = CNifBaseRecord::Write(FileHandle);
  if (!Result) return (false);

  	/* Output first three numbers */
  Result = FileHandle.WriteLong(m_Unknown1);
  if (Result) Result = FileHandle.WriteLong(m_Unknown2);
  if (Result) Result = FileHandle.WriteChar(m_Unknown3);
  if (!Result) return (false);

	/* Output values array */
  Result = FileHandle.Write((char *)&m_Values[0], sizeof(float)*NIF_PARTROT_NUMVALUES);
  if (!Result) return (false);

	/* Return success */
  return (true);
 }
/*===========================================================================
 *		End of Class Method CNifParticleRotation::Write()
 *=========================================================================*/

