/*===========================================================================
 *
 * File:	NifParticleSysController.CPP
 * Author:	Dave Humphrey (uesp@m0use.net)
 * Created On:	Tuesday, December 24, 2002
 *
 * Description
 *
 *=========================================================================*/

	/* Include Files */
#include "stdafx.h"
#include "NifParticleSysController.h"


/*===========================================================================
 *
 * Begin Local Definitions
 *
 *=========================================================================*/
  DEFINE_FILE("NifParticleSysController.cpp");
/*===========================================================================
 *		End of Local Definitions
 *=========================================================================*/


/*===========================================================================
 *
 * Class CNifParticleSystemController Constructor
 *
 *=========================================================================*/
CNifParticleSystemController::CNifParticleSystemController () {
  //DEFINE_FUNCTION("CNifParticleSystemController::CNifParticleSystemController()");
  m_pData = NULL;
  m_NumData = 0;
 }
/*===========================================================================
 *		End of Class CNifParticleSystemController Constructor
 *=========================================================================*/


/*===========================================================================
 *
 * Class CNifParticleSystemController Method - void Destroy (void);
 *
 *=========================================================================*/
void CNifParticleSystemController::Destroy (void) {
  DEFINE_FUNCTION("CNifParticleSystemController::Destroy()");
  
  DestroyArrayPointer(m_pData);
  m_NumData = 0;

  CNifBaseRecord::Destroy();
 }
/*===========================================================================
 *		End of Class Method CNifParticleSystemController::Destroy()
 *=========================================================================*/


/*===========================================================================
 *
 * Class CNifParticleSystemController Method - bool Read (FileHandle);
 *
 *=========================================================================*/
bool CNifParticleSystemController::Read (CGenFile& FileHandle) {
  DEFINE_FUNCTION("CNifParticleSystemController::Read()");
  bool Result;

  Destroy();

  Result = FileHandle.ReadLong(m_Unknown1);
  if (Result) Result = FileHandle.ReadShort(m_Unknown2);
  if (Result) Result = FileHandle.Read((char *)&m_Position1, sizeof(nifpos4_t));
  if (Result) Result = FileHandle.ReadLong(m_Unknown3);
  if (Result) Result = FileHandle.Read((char *)&m_Position2[0], sizeof(nifpos4_t)*NIF_PSC_NUMPOS2);
  if (Result) Result = FileHandle.ReadLong(m_Unknown4);
  if (Result) Result = FileHandle.ReadLong(m_Unknown5);
  if (Result) Result = FileHandle.ReadLong(m_Unknown6);
  if (Result) Result = FileHandle.ReadChar(m_Unknown7);
  if (Result) Result = FileHandle.ReadLong(m_Unknown8);
  if (Result) Result = FileHandle.ReadLong(m_Unknown9);
  if (Result) Result = FileHandle.ReadLong(m_Unknown10);
  if (Result) Result = FileHandle.ReadLong(m_Unknown11);
  if (Result) Result = FileHandle.ReadLong(m_Unknown12);
  if (Result) Result = FileHandle.ReadFloat(m_Unknown13);
  if (Result) Result = FileHandle.ReadLong(m_Unknown14);
  if (Result) Result = FileHandle.ReadLong(m_Unknown15);
  if (Result) Result = FileHandle.ReadShort(m_Unknown16);
  if (Result) Result = FileHandle.ReadShort(m_NumData);
  if (Result) Result = FileHandle.ReadShort(m_Unknown17);
  if (!Result) return (false);

  if (m_NumData < 0) {
    ErrorHandler.AddError(ERR_CUSTOM, "Invalud data size %d!", m_NumData);
    return (false);
   }

  //SystemLog.Printf ("\t\tOffset = 0x%08lX", FileHandle.Tell());

  if (m_NumData > 0) {
    CreateArrayPointer(m_pData, nifpscdata_t, m_NumData);
    Result = FileHandle.Read((char *)&m_pData[0], sizeof(nifpscdata_t)*m_NumData);
    if (!Result) return (false);
   }
  
  //SystemLog.Printf ("\t\tOffset = 0x%08lX", FileHandle.Tell());
  Result = FileHandle.ReadLong(m_Unknown18); 
  if (Result) Result = FileHandle.ReadShort(m_Unknown19); 
  if (Result) Result = FileHandle.ReadShort(m_Unknown20); 
  if (Result) Result = FileHandle.ReadLong(m_Unknown21); 
  if (Result) Result = FileHandle.ReadChar(m_Unknown22); 
  if (!Result) return (false);

  SetIsLoaded(true);
  return (true);
 }
/*===========================================================================
 *		End of Class Method CNifParticleSystemController::Read()
 *=========================================================================*/


/*===========================================================================
 *
 * Class CNifParticleSystemController Method - bool Read (FileHandle);
 *
 *=========================================================================*/
bool CNifParticleSystemController::Write (CGenFile& FileHandle) {
  //DEFINE_FUNCTION("CNifParticleSystemController::Write()");
  bool Result;

	/* Call the base class record method */
  Result = CNifBaseRecord::Write(FileHandle);
  if (!Result) return (false);

  Result = FileHandle.WriteLong(m_Unknown1);
  if (Result) Result = FileHandle.WriteShort(m_Unknown2);
  if (Result) Result = FileHandle.Write((char *)&m_Position1, sizeof(nifpos4_t));
  if (Result) Result = FileHandle.WriteLong(m_Unknown3);
  if (Result) Result = FileHandle.Write((char *)&m_Position2[0], sizeof(nifpos4_t)*NIF_PSC_NUMPOS2);
  if (Result) Result = FileHandle.WriteLong(m_Unknown4);
  if (Result) Result = FileHandle.WriteLong(m_Unknown5);
  if (Result) Result = FileHandle.WriteLong(m_Unknown6);
  if (Result) Result = FileHandle.WriteChar(m_Unknown7);
  if (Result) Result = FileHandle.WriteLong(m_Unknown8);
  if (Result) Result = FileHandle.WriteLong(m_Unknown9);
  if (Result) Result = FileHandle.WriteLong(m_Unknown10);
  if (Result) Result = FileHandle.WriteLong(m_Unknown11);
  if (Result) Result = FileHandle.WriteLong(m_Unknown12);
  if (Result) Result = FileHandle.WriteFloat(m_Unknown13);
  if (Result) Result = FileHandle.WriteLong(m_Unknown14);
  if (Result) Result = FileHandle.WriteLong(m_Unknown15);
  if (Result) Result = FileHandle.WriteShort(m_Unknown16);
  if (Result) Result = FileHandle.WriteShort(m_NumData);
  if (Result) Result = FileHandle.WriteShort(m_Unknown17);

  if (m_NumData > 0 && Result && m_pData != NULL) {
    Result = FileHandle.Write((char *)&m_pData[0], sizeof(nifpscdata_t)*m_NumData);
   }

  if (Result) Result = FileHandle.WriteLong(m_Unknown18); 
  if (Result) Result = FileHandle.WriteShort(m_Unknown19); 
  if (Result) Result = FileHandle.WriteShort(m_Unknown20); 
  if (Result) Result = FileHandle.WriteLong(m_Unknown21); 
  if (Result) Result = FileHandle.WriteChar(m_Unknown22); 
  if (!Result) return (false);

  return (true);
 }
/*===========================================================================
 *		End of Class Method CNifParticleSystemController::Write()
 *=========================================================================*/