/*===========================================================================
 *
 * File:	NifParticleSysController.H
 * Author:	Dave Humphrey (uesp@m0use.net)
 * Created On:	Tuesday, December 24, 2002
 *
 * Description
 *
 *=========================================================================*/
#ifndef __NIFPARTICLESYSTEMCONTROLLER_H
#define __NIFPARTICLESYSTEMCONTROLLER_H


/*===========================================================================
 *
 * Begin Required Includes
 *
 *=========================================================================*/
  #include "NifBase.h"
/*===========================================================================
 *		End of Required Includes
 *=========================================================================*/


/*===========================================================================
 *
 * Begin Definitions
 *
 *=========================================================================*/
  #define NIF_PSC_NUMFLOATS 10	/* Number of floats per subrecord */
  #define NIF_PSC_NUMPOS2   4
/*===========================================================================
 *		End of Definitions
 *=========================================================================*/


/*===========================================================================
 *
 * Begin Type Definitions
 *
 *=========================================================================*/

  typedef struct {
    float	Data[NIF_PSC_NUMFLOATS];
   } nifpscdata_t;

/*===========================================================================
 *		End of Type Definitions
 *=========================================================================*/


/*===========================================================================
 *
 * Begin Class CNifParticleSystemController Definition
 *
 * Description
 *
 *=========================================================================*/
class CNifParticleSystemController : public CNifBaseRecord {

  /*---------- Begin Private Class Members ----------------------*/
private:
  long			m_Unknown1;
  short			m_Unknown2;
  nifpos4_t		m_Position1;
  long			m_Unknown3;
  nifpos4_t		m_Position2[NIF_PSC_NUMPOS2];
  long			m_Unknown4;
  long			m_Unknown5;
  long			m_Unknown6;
  char			m_Unknown7;
  long			m_Unknown8;
  long			m_Unknown9;
  long			m_Unknown10;
  long			m_Unknown11;
  long			m_Unknown12;
  float			m_Unknown13;
  long			m_Unknown14;
  long			m_Unknown15;
  short			m_Unknown16;
  short			m_NumData;
  short			m_Unknown17;
  nifpscdata_t*		m_pData;
  long			m_Unknown18;
  short			m_Unknown19;
  short			m_Unknown20;
  long			m_Unknown21;
  char			m_Unknown22;


  /*---------- Begin Protected Class Methods --------------------*/
protected:


  /*---------- Begin Public Class Methods -----------------------*/
public:

	/* Class Constructors/Destructors */
  CNifParticleSystemController();
  virtual ~CNifParticleSystemController() { Destroy(); }
  virtual void Destroy (void);

	/* Input/Output the section from the current position in the file */
  virtual bool Read  (CGenFile& FileHandle);
  virtual bool Write (CGenFile& FileHandle);

 };
/*===========================================================================
 *		End of Class CNifParticleSystemController Definition
 *=========================================================================*/


#endif
/*===========================================================================
 *		End of File NifParticleSysController.H
 *=========================================================================*/
