/*===========================================================================
 *
 * File:	NifPixelData.CPP
 * Author:	Dave Humphrey (uesp@m0use.net)
 * Created On:	Tuesday, December 24, 2002
 *
 * Description
 *
 *=========================================================================*/

	/* Include Files */
#include "stdafx.h"
#include "NifPixelData.h"


/*===========================================================================
 *
 * Begin Local Definitions
 *
 *=========================================================================*/
  DEFINE_FILE("NifPixelData.cpp");
/*===========================================================================
 *		End of Local Definitions
 *=========================================================================*/


/*===========================================================================
 *
 * Class CNifPixelData Constructor
 *
 *=========================================================================*/
CNifPixelData::CNifPixelData () {
  //DEFINE_FUNCTION("CNifPixelData::CNifPixelData()");
  m_pImageInfo = NULL;
  m_pData = NULL;
  m_NumImages = 0;
 }
/*===========================================================================
 *		End of Class CNifPixelData Constructor
 *=========================================================================*/


/*===========================================================================
 *
 * Class CNifPixelData Method - void Destroy (void);
 *
 *=========================================================================*/
void CNifPixelData::Destroy (void) {
  DEFINE_FUNCTION("CNifPixelData::Destroy()");
  
  m_NumImages = 0;
  DestroyArrayPointer(m_pData);
  DestroyArrayPointer(m_pImageInfo);

  CNifBaseRecord::Destroy();
 }
/*===========================================================================
 *		End of Class Method CNifPixelData::Destroy()
 *=========================================================================*/


/*===========================================================================
 *
 * Class CNifPixelData Method - bool Read (FileHandle);
 *
 *=========================================================================*/
bool CNifPixelData::Read (CGenFile& FileHandle) {
  DEFINE_FUNCTION("CNifPixelData::Read()");
  bool Result;

  Destroy();

		/* 9 */		
  Result = FileHandle.Read((char *)&m_Values1[0], sizeof(long)*NIF_PIXELDATA_NUMVALUES1);
  if (Result) Result = FileHandle.ReadLong(m_NumImages);
  if (Result) Result = FileHandle.ReadLong(m_Unknown1);
  if (!Result) return (false);

  if (m_NumImages > 0) {
    CreateArrayPointer(m_pImageInfo, nifpixeldatarecord_t, m_NumImages);
    Result = FileHandle.Read((char *)&m_pImageInfo[0], sizeof(nifpixeldatarecord_t)*m_NumImages);
    if (!Result) return (false);
   }

  Result = FileHandle.ReadLong(m_EndOffset);
  if (!Result) return (false);

  if (m_NumImages > 0 && m_EndOffset > 0) {
    CreateArrayPointer(m_pData, char, m_EndOffset);
    Result = FileHandle.Read((char *)&m_pData[0], m_EndOffset);
    if (!Result) return (false);
   }

  //Result = FileHandle.ReadLong(m_Unknown2);
  //if (Result) Result = FileHandle.ReadLong(m_Unknown3);
  //if (!Result) return (false);

  SetIsLoaded(true);
  return (true);
 }
/*===========================================================================
 *		End of Class Method CNifPixelData::Read()
 *=========================================================================*/


/*===========================================================================
 *
 * Class CNifPixelData Method - bool Read (FileHandle);
 *
 *=========================================================================*/
bool CNifPixelData::Write (CGenFile& FileHandle) {
  //DEFINE_FUNCTION("CNifPixelData::Write()");
  bool Result;

	/* Call the base class record method */
  Result = CNifBaseRecord::Write(FileHandle);
  if (!Result) return (false);

  Result = FileHandle.Write((char *)&m_Values1[0], sizeof(long)*NIF_PIXELDATA_NUMVALUES1);
  if (Result) Result = FileHandle.WriteLong(m_NumImages);
  if (Result) Result = FileHandle.WriteLong(m_Unknown1);
  if (!Result) return (false);

  if (m_NumImages > 0) {
    Result = FileHandle.Write((char *)&m_pImageInfo[0], sizeof(nifpixeldatarecord_t)*m_NumImages);
    if (!Result) return (false);
   }

  Result = FileHandle.WriteLong(m_EndOffset);
  if (!Result) return (false);

  if (m_NumImages > 0 && m_EndOffset > 0) {
    Result = FileHandle.Write((char *)&m_pData[0], m_EndOffset);
    if (!Result) return (false);
   }

  //Result = FileHandle.WriteLong(m_Unknown2);
  //if (Result) Result = FileHandle.WriteLong(m_Unknown3);
  //if (!Result) return (false);

  return (true);
 }
/*===========================================================================
 *		End of Class Method CNifPixelData::Write()
 *=========================================================================*/