/*===========================================================================
 *
 * File:	NifPixelData.H
 * Author:	Dave Humphrey (uesp@m0use.net)
 * Created On:	Tuesday, December 24, 2002
 *
 * Description
 *
 *=========================================================================*/
#ifndef __NIFPIXELDATA_H
#define __NIFPIXELDATA_H


/*===========================================================================
 *
 * Begin Required Includes
 *
 *=========================================================================*/
  #include "NifBase.h"
/*===========================================================================
 *		End of Required Includes
 *=========================================================================*/


/*===========================================================================
 *
 * Begin Definitions
 *
 *=========================================================================*/
  #define NIF_PIXELDATA_NUMVALUES1 9
/*===========================================================================
 *		End of Definitions
 *=========================================================================*/



/*===========================================================================
 *
 * Begin Type Definitions
 *
 *=========================================================================*/
#pragma pack(push, 1)

  typedef struct {
    long	Width;
    long	Height;
    long	Offset;
   } nifpixeldatarecord_t;

#pragma pack(pop)
/*===========================================================================
 *		End of Type Definitions
 *=========================================================================*/


/*===========================================================================
 *
 * Begin Class CNifPixelData Definition
 *
 * Description
 *
 *=========================================================================*/
class CNifPixelData : public CNifBaseRecord {

  /*---------- Begin Private Class Members ----------------------*/
private:
  long			m_Values1[NIF_PIXELDATA_NUMVALUES1];
  long			m_NumImages;
  long			m_Unknown1;
  nifpixeldatarecord_t*	m_pImageInfo;
  long			m_EndOffset;
  char*			m_pData;
  long			m_Unknown2;
  long			m_Unknown3;


  /*---------- Begin Protected Class Methods --------------------*/
protected:


  /*---------- Begin Public Class Methods -----------------------*/
public:

	/* Class Constructors/Destructors */
  CNifPixelData();
  virtual ~CNifPixelData() { Destroy(); }
  virtual void Destroy (void);

	/* Input/Output the section from the current position in the file */
  virtual bool Read  (CGenFile& FileHandle);
  virtual bool Write (CGenFile& FileHandle);

 };
/*===========================================================================
 *		End of Class CNifPixelData Definition
 *=========================================================================*/


#endif
/*===========================================================================
 *		End of File NifVisData.H
 *=========================================================================*/
