/*===========================================================================
 *
 * File:	Nifrootcollisionnode.CPP
 * Author:	Dave Humphrey (uesp@m0use.net)
 * Created On:	December 11, 2002
 *
 * Description
 *
 *=========================================================================*/

	/* Include Files */
#include "stdafx.h"
#include "nifrootcollisonnode.h"


/*===========================================================================
 *
 * Begin Local Definitions
 *
 *=========================================================================*/
  DEFINE_FILE("NinfRootCollisionNode.cpp");
/*===========================================================================
 *		End of Local Definitions
 *=========================================================================*/


/*===========================================================================
 *
 * Class CNifRootCollisionNode Constructor
 *
 *=========================================================================*/
CNifRootCollisionNode::CNifRootCollisionNode () {
  //DEFINE_FUNCTION("CNifRootCollisionNode::CNifRootCollisionNode()");
 }
/*===========================================================================
 *		End of Class CNifRootCollisionNode Constructor
 *=========================================================================*/


/*===========================================================================
 *
 * Class CNifRootCollisionNode Method - void Destroy (void);
 *
 * Description
 *
 *=========================================================================*/
void CNifRootCollisionNode::Destroy (void) {
  //DEFINE_FUNCTION("CNifRootCollisionNode::Destroy()");
  m_Values1.Destroy();

  CNifBaseRecord::Destroy();
 }
/*===========================================================================
 *		End of Class Method CNifRootCollisionNode::Destroy()
 *=========================================================================*/


/*===========================================================================
 *
 * Class CNifRootCollisionNode Method - bool Read (FileHandle);
 *
 * Description
 *
 *=========================================================================*/
bool CNifRootCollisionNode::Read (CGenFile& FileHandle) {
  //DEFINE_FUNCTION("CNifRootCollisionNode::Read()");
  bool    Result;
  CString TempString;

	/* Destroy the current contents */
  Destroy();

	/* Input the rest of the data */
  Result = NifReadString(FileHandle, m_NodeString);
  if (Result) Result = FileHandle.ReadLong(m_Unknown1);
  if (Result) Result = FileHandle.ReadLong(m_Unknown2);
  if (Result) Result = FileHandle.ReadShort(m_Unknown3);
  if (Result) Result = FileHandle.Read((char *)&m_Values[0], sizeof(float)*NIF_COLNODE_NUMVALUES);
  if (!Result) return (false);

  Result = m_Values1.Read(FileHandle);
  if (Result) Result = FileHandle.ReadLong(m_Unknown4);
  if (!Result) return (false);

  SetIsLoaded(true);
  return (true);
 }
/*===========================================================================
 *		End of Class Method CNifRootCollisionNode::Read()
 *=========================================================================*/


/*===========================================================================
 *
 * Class CNifRootCollisionNode Method - bool Write (FileHandle);
 *
 * Description
 *
 *=========================================================================*/
bool CNifRootCollisionNode::Write (CGenFile& FileHandle) {
  //DEFINE_FUNCTION("CNifRootCollisionNode::Write()");
  bool    Result;

	/* Call the base class method first */
  Result = CNifBaseRecord::Write(FileHandle);
  if (!Result) return (false);

  Result = NifWriteString(FileHandle, m_NodeString);
  if (Result) Result = FileHandle.WriteLong(m_Unknown1);
  if (Result) Result = FileHandle.WriteLong(m_Unknown2);
  if (Result) Result = FileHandle.WriteShort(m_Unknown3);
  if (Result) Result = FileHandle.Write((char *)&m_Values[0], sizeof(float)*NIF_COLNODE_NUMVALUES);

  if (Result) Result = m_Values1.Write(FileHandle);
  if (Result) Result = FileHandle.WriteLong(m_Unknown4);
  if (!Result) return (false);

  return (Result);
 }
/*===========================================================================
 *		End of Class Method CNifRootCollisionNode::Write()
 *=========================================================================*/

