/*===========================================================================
 *
 * File:	NifRotatingParticles.CPP
 * Author:	Dave Humphrey (uesp@m0use.net)
 * Created On:	Tuesday, December 24, 2002
 *
 * Description
 *
 * 26 October 2003
 *	- Changed the static long array to a combination of a dynamic long
 *	  array and 3 long values.
 *
 *=========================================================================*/

	/* Include Files */
#include "stdafx.h"
#include "NifRotatingParticles.h"


/*===========================================================================
 *
 * Begin Local Definitions
 *
 *=========================================================================*/
  DEFINE_FILE("NifRotatingParticles.cpp");
/*===========================================================================
 *		End of Local Definitions
 *=========================================================================*/


/*===========================================================================
 *
 * Class CNifRotatingParticles Constructor
 *
 *=========================================================================*/
CNifRotatingParticles::CNifRotatingParticles () {
  //DEFINE_FUNCTION("CNifRotatingParticles::CNifRotatingParticles()");
  
 }
/*===========================================================================
 *		End of Class CNifRotatingParticles Constructor
 *=========================================================================*/


/*===========================================================================
 *
 * Class CNifRotatingParticles Method - void Destroy (void);
 *
 *=========================================================================*/
void CNifRotatingParticles::Destroy (void) {
  //DEFINE_FUNCTION("CNifRotatingParticles::Destroy()");
  m_LongArray.Destroy();
  CNifBaseRecord::Destroy();
 }
/*===========================================================================
 *		End of Class Method CNifRotatingParticles::Destroy()
 *=========================================================================*/


/*===========================================================================
 *
 * Class CNifRotatingParticles Method - bool Read (FileHandle);
 *
 *=========================================================================*/
bool CNifRotatingParticles::Read (CGenFile& FileHandle) {
  //DEFINE_FUNCTION("CNifRotatingParticles::Read()");
  bool Result;

  Destroy();

  Result = NifReadString(FileHandle, m_ParticleName);
  if (Result) Result = FileHandle.ReadLong(m_Unknown1);
  if (Result) Result = FileHandle.ReadLong(m_Unknown2);
  if (Result) Result = FileHandle.ReadLong(m_Unknown3);
  if (Result) Result = FileHandle.ReadShort(m_Unknown4);
  if (Result) Result = FileHandle.Read((char *)&m_Floats[0], sizeof(float)*NIF_ROTPART_NUMFLOATS);

  if (Result) Result = m_LongArray.Read(FileHandle);
  if (Result) Result = FileHandle.Read((char *)&m_Values1[0], sizeof(long)*NIF_ROTPART_NUMLONGS1);
  //if (Result) Result = FileHandle.Read((char *)&m_Values[0], sizeof(long)*NIF_ROTPART_NUMLONGS);
  if (!Result) return (false);

  SetIsLoaded(true);
  return (true);
 }
/*===========================================================================
 *		End of Class Method CNifRotatingParticles::Read()
 *=========================================================================*/


/*===========================================================================
 *
 * Class CNifRotatingParticles Method - bool Read (FileHandle);
 *
 *=========================================================================*/
bool CNifRotatingParticles::Write (CGenFile& FileHandle) {
  //DEFINE_FUNCTION("CNifRotatingParticles::Write()");
  bool Result;

	/* Call the base class record method */
  Result = CNifBaseRecord::Write(FileHandle);
  if (!Result) return (false);

  Result = NifWriteString(FileHandle, m_ParticleName);
  if (Result) Result = FileHandle.WriteLong(m_Unknown1);
  if (Result) Result = FileHandle.WriteLong(m_Unknown2);
  if (Result) Result = FileHandle.WriteLong(m_Unknown3);
  if (Result) Result = FileHandle.WriteShort(m_Unknown4);
  if (Result) Result = FileHandle.Write((char *)&m_Floats[0], sizeof(float)*NIF_ROTPART_NUMFLOATS);

  if (Result) Result = m_LongArray.Write(FileHandle);
  if (Result) Result = FileHandle.Write((char *)&m_Values1[0], sizeof(long)*NIF_ROTPART_NUMLONGS1);

  //if (Result) Result = FileHandle.Write((char *)&m_Values[0], sizeof(long)*NIF_ROTPART_NUMLONGS);
  if (!Result) return (false);

  return (true);
 }
/*===========================================================================
 *		End of Class Method CNifRotatingParticles::Write()
 *=========================================================================*/