/*===========================================================================
 *
 * File:	NifShadeProperty.H
 * Author:	Dave Humphrey (uesp@m0use.net)
 * Created On:	December 11, 2002
 *
 * Description
 *
 *=========================================================================*/
#ifndef __NIFSHADEPROPERTY_H
#define __NIFSHADEPROPERTY_H


/*===========================================================================
 *
 * Begin Required Includes
 *
 *=========================================================================*/
  #include "NifBase.h"
/*===========================================================================
 *		End of Required Includes
 *=========================================================================*/


/*===========================================================================
 *
 * Begin Definitions
 *
 *=========================================================================*/

	/* Number of values in the material data */
  #define NIF_SHADEPROP_NUMVALUES 14

/*===========================================================================
 *		End of Definitions
 *=========================================================================*/


/*===========================================================================
 *
 * Begin Class CNifShadeProperty Definition
 *
 * Description
 *
 *=========================================================================*/
class CNifShadeProperty : public CNifBaseRecord {

  /*---------- Begin Private Class Members ----------------------*/
private:
  CString	m_ShadeName;		/* Name of optional texture */

  long		m_Unknown1;		/* Unknown numbers */
  long		m_Unknown2;	
  short		m_Unknown3;


  /*---------- Begin Protected Class Methods --------------------*/
protected:


  /*---------- Begin Public Class Methods -----------------------*/
public:

	/* Class Constructors/Destructors */
  CNifShadeProperty();
  virtual ~CNifShadeProperty() { Destroy(); }
  virtual void Destroy (void);

  	/* Return the optional record name */
  virtual const char*  GetRecordName  (void) const { return (m_ShadeName); }

	/* Get class members */
  short GetUnknown3 (void) const { return (m_Unknown3); }

	/* Input/Output the section from the current position in the file */
  virtual bool Read  (CGenFile& FileHandle);
  virtual bool Write (CGenFile& FileHandle);

 };
/*===========================================================================
 *		End of Class CNifShadeProperty Definition
 *=========================================================================*/


#endif
/*===========================================================================
 *		End of File Nifmaterialproperty.H
 *=========================================================================*/
