/*===========================================================================
 *
 * File:	NifShortArray.CPP
 * Author:	Dave Humphrey (uesp@m0use.net)
 * Created On:	Monday, December 23, 2002
 *
 * Description
 *
 *=========================================================================*/

	/* Include Files */
#include "stdafx.h"
#include "nifshortarray.h"


/*===========================================================================
 *
 * Begin Required Includes
 *
 *=========================================================================*/
  DEFINE_FILE("NifShortArray.cpp");
/*===========================================================================
 *		End of Required Includes
 *=========================================================================*/


/*===========================================================================
 *
 * Class CNifShortArray Constructor
 *
 *=========================================================================*/
CNifShortArray::CNifShortArray () {
  //DEFINE_FUNCTION("CNifShortArray::CNifShortArray()");
 m_Size = 0;
 m_AllocatedSize = 0;
 m_pData = NULL;
 }
/*===========================================================================
 *		End of Class CNifShortArray Constructor
 *=========================================================================*/


/*===========================================================================
 *
 * Class CNifShortArray Method - void Destroy (void);
 *
 * Description
 *
 *=========================================================================*/
void CNifShortArray::Destroy (void) {
  DEFINE_FUNCTION("CNifShortArray::Destroy()");

  DestroyArrayPointer(m_pData);
  m_Size = 0;
  m_AllocatedSize = 0;
 }
/*===========================================================================
 *		End of Class Method CNifShortArray::Destroy()
 *=========================================================================*/


/*===========================================================================
 *
 * Class CNifShortArray Method - bool Read (CGenFile& FileHandle);
 *
 * Description
 *
 *=========================================================================*/
bool CNifShortArray::Read (CGenFile& FileHandle) {
  DEFINE_FUNCTION("CNifShortArray::Read()");
  bool Result;

  Destroy();

	/* Input the long array size value */
  Result = FileHandle.ReadShort(m_Size);
  if (!Result) return (false);

	/* Ensure a valid input size */
  if (m_Size < 0) {
    ErrorHandler.AddError(ERR_CUSTOM, "Invalid array size input (%d)!", (int)m_Size);
    return (false);
   }

  if (m_Size == 0) {
    m_AllocatedSize = 0;
    return (true);
   }

	/* Allocate the array */
  CreateArrayPointer(m_pData, short, m_Size);
  m_AllocatedSize = m_Size;

	/* Input the array */
  Result = FileHandle.Read((char *)m_pData, sizeof(short)*m_Size);
  return (Result);
 }
/*===========================================================================
 *		End of Class Method CNifShortArray::Read()
 *=========================================================================*/


/*===========================================================================
 *
 * Class CNifShortArray Method - bool Write (CGenFile& FileHandle);
 *
 * Description
 *
 *=========================================================================*/
bool CNifShortArray::Write (CGenFile& FileHandle) {
  DEFINE_FUNCTION("CNifShortArray::Write()");
  bool Result;

	/* Output the long array size value */
  Result = FileHandle.WriteShort(m_Size);
  if (!Result) return (false);

	/* Ensure a valid input size */
  if (m_Size <= 0 || m_pData == NULL) return (true);

  Result = FileHandle.Write((char *)m_pData, sizeof(short)*m_Size);
  return (Result);
 }
/*===========================================================================
 *		End of Class Method CNifShortArray::Write()
 *=========================================================================*/
