/*===========================================================================
 *
 * File:	NifShortArray.H
 * Author:	Dave Humphrey (uesp@m0use.net)
 * Created On:	Monday, December 23, 2002
 *
 * Description
 *
 *=========================================================================*/
#ifndef __NIFSHORTARRAY_H
#define __NIFSHORTARRAY_H


/*===========================================================================
 *
 * Begin Required Includes
 *
 *=========================================================================*/
  #include "NifBase.h"
/*===========================================================================
 *		End of Required Includes
 *=========================================================================*/


/*===========================================================================
 *
 * Begin Class CNifShortArray Definition
 *
 * Description
 *
 *=========================================================================*/
class CNifShortArray {

  /*---------- Begin Private Class Members ----------------------*/
private:
  short  m_Size;
  short* m_pData;
  short  m_AllocatedSize;


  /*---------- Begin Protected Class Methods --------------------*/
protected:


  /*---------- Begin Public Class Methods -----------------------*/
public:

	/* Class Constructors/Destructors */
  CNifShortArray();
  virtual ~CNifShortArray() { Destroy(); }
  virtual void Destroy (void);

	/* Get class members */
  short GetSize          (void) const { return (m_Size); }
  short GetAllocatedSize (void) const { return (m_AllocatedSize); }
  short GetAt	 	 (const short Index) const { return (IsValidIndex(Index) ? m_pData[Index] : -1); }
  bool IsValidIndex	 (const short Index) const { return (Index >= 0 && Index < m_Size); }

	/* Input/Output the section from the current position in the file */
  virtual bool Read  (CGenFile& FileHandle);
  virtual bool Write (CGenFile& FileHandle);

 };
/*===========================================================================
 *		End of Class CNifShortArray Definition
 *=========================================================================*/


#endif
/*===========================================================================
 *		End of File NifShortArray.H
 *=========================================================================*/
