/*===========================================================================
 *
 * File:	Nifsourcetexture.H
 * Author:	Dave Humphrey (uesp@m0use.net)
 * Created On:	December 11, 2002
 *
 * Description
 *
 *=========================================================================*/
#ifndef __NIFSOURCETEXTURE_H
#define __NIFSOURCETEXTURE_H


/*===========================================================================
 *
 * Begin Required Includes
 *
 *=========================================================================*/
  #include "NifBase.h"
/*===========================================================================
 *		End of Required Includes
 *=========================================================================*/


/*===========================================================================
 *
 * Begin Class CNifSourceTexture Definition
 *
 * Description
 *
 *=========================================================================*/
class CNifSourceTexture : public CNifBaseRecord {

  /*---------- Begin Private Class Members ----------------------*/
private:
  long		m_Unknown1;
  long		m_Unknown2;
  long		m_Unknown3;
  char		m_Unknown4;
  char		m_Unknown4a;
  long		m_Unknown4b;
  long		m_Unknown5;
  long		m_Unknown6;
  long		m_Unknown7;
  char		m_Unknown8;

  CString	m_TextureName;


  /*---------- Begin Protected Class Methods --------------------*/
protected:


  /*---------- Begin Public Class Methods -----------------------*/
public:

	/* Class Constructors/Destructors */
  CNifSourceTexture();
  virtual ~CNifSourceTexture() { Destroy(); }
  virtual void Destroy (void);

	/* Get class members */
  CString& GetTextureName (void) { return (m_TextureName); }

  	/* Return the optional record name */
  virtual const char*  GetRecordName  (void) const { return (m_TextureName); }

	/* Input/Output the section from the current position in the file */
  virtual bool Read  (CGenFile& FileHandle);
  virtual bool Write (CGenFile& FileHandle);

	/* Set class members */
  void SetTextureName (const TCHAR* pName) { m_TextureName = pName; }

 };
/*===========================================================================
 *		End of Class CNifSourceTexture Definition
 *=========================================================================*/



#endif
/*===========================================================================
 *		End of File Nifsourcetexture.H
 *=========================================================================*/
