/*===========================================================================
 *
 * File:	Niftextkeyextradata.CPP
 * Author:	Dave Humphrey (uesp@m0use.net)
 * Created On:	Monday, December 23, 2002
 *
 * Description
 *
 *=========================================================================*/

	/* Include Files */
#include "stdafx.h"
#include "niftextkeyextradata.h"


/*===========================================================================
 *
 * Begin Local Definitions
 *
 *=========================================================================*/
  DEFINE_FILE("NifTextKeyExtraData.cpp");
/*===========================================================================
 *		End of Local Definitions
 *=========================================================================*/


/*===========================================================================
 *
 * Class CNifTextKeyData Method - bool Read (CGenFile& FileHandle);
 *
 * Description
 *
 *=========================================================================*/
bool CNifTextKeyData::Read (CGenFile& FileHandle) {
  //DEFINE_FUNCTION("CNifTextKeyData::Read()");
  bool Result;

  Result = FileHandle.ReadLong(m_Data);
  if (Result) Result = NifReadString(FileHandle, m_Text);

  return (Result);
 }
/*===========================================================================
 *		End of Class Method CNifTextKeyData::Read()
 *=========================================================================*/


/*===========================================================================
 *
 * Class CNifTextKeyData Method - bool Write (CGenFile& FileHandle);
 *
 * Description
 *
 *=========================================================================*/
bool CNifTextKeyData::Write (CGenFile& FileHandle) {
  //DEFINE_FUNCTION("CNifTextKeyData::Write()");
  bool Result;

  Result = FileHandle.WriteLong(m_Data);
  if (Result) Result = NifWriteString(FileHandle, m_Text);

  return (Result);
 }
/*===========================================================================
 *		End of Class Method CNifTextKeyData::Write()
 *=========================================================================*/


/*===========================================================================
 *
 * Class CNifTextKeyExtraData Constructor
 *
 *=========================================================================*/
CNifTextKeyExtraData::CNifTextKeyExtraData () {
  //DEFINE_FUNCTION("CNifTextKeyExtraData::CNifTextKeyExtraData()");
  m_TextCount = 0;
  m_pKeyData = NULL;
 }
/*===========================================================================
 *		End of Class CNifTextKeyExtraData Constructor
 *=========================================================================*/


/*===========================================================================
 *
 * Class CNifTextKeyExtraData Method - void Destroy ();
 *
 * Description
 *
 *=========================================================================*/
void CNifTextKeyExtraData::Destroy () {
  DEFINE_FUNCTION("CNifTextKeyExtraData::Destroy()");

  m_TextCount = 0;
  DestroyArrayPointer(m_pKeyData);

  CNifBaseRecord::Destroy();
 }
/*===========================================================================
 *		End of Class Method CNifTextKeyExtraData::Destroy()
 *=========================================================================*/



/*===========================================================================
 *
 * Class CNifTextKeyExtraData Method - bool Read (CGenFile& FileHandle);
 *
 * Description
 *
 *=========================================================================*/
bool CNifTextKeyExtraData::Read (CGenFile& FileHandle) {
  DEFINE_FUNCTION("CNifTextKeyExtraData::Read()");
  bool Result;
  int  Index;

  Destroy();

  Result = FileHandle.ReadLong(m_Unknown1);
  if (Result) Result = FileHandle.ReadLong(m_Unknown2);
  if (Result) Result = FileHandle.ReadLong(m_TextCount);
  if (!Result) return (false);

  if (m_TextCount < 0) {
    ErrorHandler.AddError(ERR_CUSTOM, "Invalid key text count!");
    return (false);
   }

  if (m_TextCount > 0) {
    CreateArrayPointer(m_pKeyData, CNifTextKeyData, m_TextCount);

    for (Index = 0; Index < m_TextCount; Index++) {
      //SystemLog.Printf ("\t\tOffset %d = 0x%08lX", Index, FileHandle.Tell());
      Result = m_pKeyData[Index].Read(FileHandle);
      if (!Result) return (false);
     }
   }

  SetIsLoaded(true);
  return (true);
 }
/*===========================================================================
 *		End of Class Method CNifTextKeyExtraData::Read()
 *=========================================================================*/


/*===========================================================================
 *
 * Class CNifTextKeyExtraData Method - bool Write (CGenFile& FileHandle);
 *
 * Description
 *
 *=========================================================================*/
bool CNifTextKeyExtraData::Write (CGenFile& FileHandle) {
  //DEFINE_FUNCTION("CNifTextKeyExtraData::Write()");
  bool Result;
  int  Index;

  Result = CNifBaseRecord::Write(FileHandle);
  if (!Result) return (false);

  Result = FileHandle.WriteLong(m_Unknown1);
  if (Result) Result = FileHandle.WriteLong(m_Unknown2);
  if (Result) Result = FileHandle.WriteLong(m_TextCount);
  if (!Result) return (false);

  for (Index = 0; Index < m_TextCount; Index++) {
    Result = m_pKeyData[Index].Write(FileHandle);
    if (!Result) return (false);
   }

  return (true);
 }
/*===========================================================================
 *		End of Class Method CNifTextKeyExtraData::Write()
 *=========================================================================*/