/*===========================================================================
 *
 * File:	Niftextureproperty.CPP
 * Author:	Dave Humphrey (uesp@m0use.net)
 * Created On:	December 11, 2002
 *
 * Description
 *
 * 26 October 2003
 *	- Redid basically the complete record format.
 *
 *=========================================================================*/

	/* Include Files */
#include "stdafx.h"
#include "niftextureproperty.h"



/*===========================================================================
 *
 * Begin Local Definitions
 *
 *=========================================================================*/
  DEFINE_FILE("NifTextureProperty.cpp");
/*===========================================================================
 *		End of Local Definitions
 *=========================================================================*/


/*===========================================================================
 *
 * Class CNifTexturingProperty Constructor
 *
 *=========================================================================*/
CNifTexturingProperty::CNifTexturingProperty () {
  //DEFINE_FUNCTION("CNifTexturingProperty::CNifTexturingProperty()");
 }
/*===========================================================================
 *		End of Class CNifTexturingProperty Constructor
 *=========================================================================*/


/*===========================================================================
 *
 * Class CNifTexturingProperty Method - void Destroy (void);
 *
 *=========================================================================*/
void CNifTexturingProperty::Destroy (void) {
  DEFINE_FUNCTION("CNifTexturingProperty::Destroy()");

	/* Call the base class method */
  CNifBaseRecord::Destroy();
 }
/*===========================================================================
 *		End of Class Method CNifTexturingProperty::Destroy()
 *=========================================================================*/


/*===========================================================================
 *
 * Class CNifTexturingProperty Method - bool Read (FileHandle);
 *
 * Input the node data from the current position in the given file.  Assumes
 * that the current position in the file is the byte after the last character
 * in the "NifNode" name record header.  Returns false on any error.
 *
 *=========================================================================*/
bool CNifTexturingProperty::Read (CGenFile& FileHandle) {
  bool Result;

	/* Delete the current record contents */
  Destroy();

  Result = FileHandle.ReadLong(m_Unknown1);
  if (Result) Result = FileHandle.ReadLong(m_Unknown2);
  if (Result) Result = FileHandle.ReadLong(m_Unknown3);
  if (Result) Result = FileHandle.ReadShort(m_Unknown4);
  //if (Result) Result = FileHandle.Read((char *)&m_Values[0], sizeof(long)*NIF_TEXPROP_NUMVALUES);
  if (Result) Result = FileHandle.ReadLong(m_Unknown5);
  if (Result) Result = FileHandle.ReadShort(m_Unknown6);
  if (!Result) return (false);

  Result = FileHandle.ReadLong(m_Unknown0a);
  if (!Result) return (false);

  if ((ulong)m_Unknown0a > 0xFFFF) {
    Result = FileHandle.Read((char *)&m_Values0[0], NIF_TEXPROP_VALUES1ASIZE);
    if (!Result) return (false);
   }
  
  Result = FileHandle.ReadLong(m_Unknown1a);
  if (!Result) return (false);

  if ((ulong)m_Unknown1a > 0xFFFF) {
    Result = FileHandle.Read((char *)&m_Values1[0], NIF_TEXPROP_VALUES1ASIZE);
    if (!Result) return (false);
   }

  Result = FileHandle.ReadLong(m_Unknown2a);
  if (!Result) return (false);

  if ((ulong)m_Unknown2a > 0xFFFF) {
    Result = FileHandle.Read((char *)&m_Values2[0], NIF_TEXPROP_VALUES1ASIZE);
    if (!Result) return (false);
   }

  Result = FileHandle.ReadLong(m_Unknown3a);
  if (!Result) return (false);

  if ((ulong)m_Unknown3a > 0xFFFF) {
    Result = FileHandle.Read((char *)&m_Values3[0], NIF_TEXPROP_VALUES1ASIZE);
    if (!Result) return (false);
   }

  Result = FileHandle.ReadLong(m_Unknown4a);
  if (!Result) return (false);

  if ((ulong)m_Unknown4a > 0xFFFF) {
    Result = FileHandle.Read((char *)&m_Values4[0], NIF_TEXPROP_VALUES1ASIZE);
    if (!Result) return (false);
   }

  Result = FileHandle.ReadLong(m_Unknown5a);
  if (!Result) return (false);

  if ((ulong)m_Unknown5a > 0xFFFF) {
    Result = FileHandle.Read((char *)&m_Values5[0], NIF_TEXPROP_VALUES1ASIZE);
    if (!Result) return (false);
   }

  Result = FileHandle.ReadShort(m_Unknown6a);
  if (!Result) return (false);

  if ((ulong)m_Unknown5a > 0xFFFF) {
    Result = FileHandle.Read((char *)&m_Floats7a[0], NIF_TEXPROP_NUMFLOATS*sizeof(float));
    if (!Result) return (false);
   }

  Result = FileHandle.ReadLong(m_Unknown8a);
  if (!Result) return (false);

  if ((ulong)m_Unknown8a > 0xFFFF) {
    Result = FileHandle.Read((char *)&m_Values8[0], NIF_TEXPROP_VALUES1ASIZE);
    if (!Result) return (false);
   }

	/* Return success */
  SetIsLoaded(true);
  return (true);
 }
/*===========================================================================
 *		End of Class Method CNifTexturingProperty::Read()
 *=========================================================================*/
  

/*===========================================================================
 *
 * Class CNifTexturingProperty Method - bool Write (FileHandle);
 *
 * Input the node data to the current position in the given file.  Outputs the
 * record header and data.  Returns false on any error.
 *
 *=========================================================================*/
bool CNifTexturingProperty::Write (CGenFile& FileHandle) {
  bool Result;

	/* Call the base class method first */
  Result = CNifBaseRecord::Write(FileHandle);
  if (!Result) return (false);

  Result = FileHandle.WriteLong(m_Unknown1);
  if (Result) Result = FileHandle.WriteLong(m_Unknown2);
  if (Result) Result = FileHandle.WriteLong(m_Unknown3);
  if (Result) Result = FileHandle.WriteShort(m_Unknown4);
  //if (Result) Result = FileHandle.Write((char *)&m_Values[0], sizeof(long)*NIF_TEXPROP_NUMVALUES);
  if (Result) Result = FileHandle.WriteLong(m_Unknown5);
  if (Result) Result = FileHandle.WriteShort(m_Unknown6);
  if (!Result) return (false);

  Result = FileHandle.WriteLong(m_Unknown0a);
  if (!Result) return (false);

  if ((ulong)m_Unknown0a > 0xFFFF) {
    Result = FileHandle.Write((char *)&m_Values0[0], NIF_TEXPROP_VALUES1ASIZE);
    if (!Result) return (false);
   }

  Result = FileHandle.WriteLong(m_Unknown1a);
  if (!Result) return (false);

  if ((ulong)m_Unknown1a > 0xFFFF) {
    Result = FileHandle.Write((char *)&m_Values1[0], NIF_TEXPROP_VALUES1ASIZE);
    if (!Result) return (false);
   }

  Result = FileHandle.WriteLong(m_Unknown2a);
  if (!Result) return (false);

  if ((ulong)m_Unknown2a > 0xFFFF) {
    Result = FileHandle.Write((char *)&m_Values2[0], NIF_TEXPROP_VALUES1ASIZE);
    if (!Result) return (false);
   }

  Result = FileHandle.WriteLong(m_Unknown3a);
  if (!Result) return (false);

  if ((ulong)m_Unknown3a > 0xFFFF) {
    Result = FileHandle.Write((char *)&m_Values3[0], NIF_TEXPROP_VALUES1ASIZE);
    if (!Result) return (false);
   }

  Result = FileHandle.WriteLong(m_Unknown4a);
  if (!Result) return (false);

  if ((ulong)m_Unknown4a > 0xFFFF) {
    Result = FileHandle.Write((char *)&m_Values4[0], NIF_TEXPROP_VALUES1ASIZE);
    if (!Result) return (false);
   }

  Result = FileHandle.WriteLong(m_Unknown5a);
  if (!Result) return (false);

  if ((ulong)m_Unknown5a > 0xFFFF) {
    Result = FileHandle.Write((char *)&m_Values5[0], NIF_TEXPROP_VALUES1ASIZE);
    if (!Result) return (false);
   }

  Result = FileHandle.WriteShort(m_Unknown6a);
  if (!Result) return (false);

  if ((ulong)m_Unknown5a > 0xFFFF) {
    Result = FileHandle.Write((char *)&m_Floats7a[0], NIF_TEXPROP_NUMFLOATS*sizeof(float));
    if (!Result) return (false);
   }

  Result = FileHandle.WriteLong(m_Unknown8a);
  if (!Result) return (false);

  if ((ulong)m_Unknown8a > 0xFFFF) {
    Result = FileHandle.Write((char *)&m_Values8[0], NIF_TEXPROP_VALUES1ASIZE);
    if (!Result) return (false);
   }

	/* Return success */
  return (Result);
 }
/*===========================================================================
 *		End of Class Method CNifTexturingProperty::Write()
 *=========================================================================*/