/*===========================================================================
 *
 * File:	Nitextureproperty.H
 * Author:	Dave Humphrey (uesp@m0use.net)
 * Created On:	December 11, 2002
 *
 * Description
 *
 *=========================================================================*/
#ifndef __NITEXTUREPROPERTY_H
#define __NITEXTUREPROPERTY_H


/*===========================================================================
 *
 * Begin Required Includes
 *
 *=========================================================================*/
  #include "NifBase.h"
/*===========================================================================
 *		End of Required Includes
 *=========================================================================*/


/*===========================================================================
 *
 * Begin Definitions
 *
 *=========================================================================*/
  #define NIF_TEXPROP_UNKNOWN5SIZE  22
  #define NIF_TEXPROP_UNKNOWN8SIZE  68

  #define NIF_TEXPROP_NUMVALUES     8
  #define NIF_TEXPROP_VALUES1ASIZE  22
  #define NIF_TEXPROP_NUMFLOATS     6
/*===========================================================================
 *		End of Definitions
 *=========================================================================*/


/*===========================================================================
 *
 * Begin Class CNifTexturingProperty Definition
 *
 * Description
 *
 *=========================================================================*/
class CNifTexturingProperty : public CNifBaseRecord {

  /*---------- Begin Private Class Members ----------------------*/
private:
  long		m_Unknown1;
  long		m_Unknown2;
  long		m_Unknown3;
  short		m_Unknown4;

  long		m_Unknown5;
  short		m_Unknown6;
  
  long		m_Unknown0a;
  long		m_Unknown1a;
  long		m_Unknown2a;
  long		m_Unknown3a;
  long		m_Unknown4a;
  long		m_Unknown5a;
  char		m_Values0[NIF_TEXPROP_VALUES1ASIZE];
  char		m_Values1[NIF_TEXPROP_VALUES1ASIZE];
  char		m_Values2[NIF_TEXPROP_VALUES1ASIZE];
  char		m_Values3[NIF_TEXPROP_VALUES1ASIZE];
  char		m_Values4[NIF_TEXPROP_VALUES1ASIZE];
  char		m_Values5[NIF_TEXPROP_VALUES1ASIZE];
  short		m_Unknown6a;
  float		m_Floats7a[NIF_TEXPROP_NUMFLOATS];
  long		m_Unknown8a;
  char		m_Values8[NIF_TEXPROP_VALUES1ASIZE];
  

  /*---------- Begin Protected Class Methods --------------------*/
protected:


  /*---------- Begin Public Class Methods -----------------------*/
public:

	/* Class Constructors/Destructors */
  CNifTexturingProperty();
  virtual ~CNifTexturingProperty() { Destroy(); }
  virtual void Destroy (void);

	/* Get class members */
  bool HasTextureIndex (void) const { return ((ulong)m_Unknown0a > 0xFFFF); }
  long GetTextureIndex (void) const { return (HasTextureIndex() ? *(long *)(m_Values0 + 2): -1); }

	/* Input/Output the section from the current position in the file */
  virtual bool Read  (CGenFile& FileHandle);
  virtual bool Write (CGenFile& FileHandle);

 };
/*===========================================================================
 *		End of Class CNifTexturingProperty Definition
 *=========================================================================*/


#endif
/*===========================================================================
 *		End of File Nitextureproperty.H
 *=========================================================================*/
