/*===========================================================================
 *
 * File:	Niftypes.H
 * Author:	Dave Humphrey (uesp@m0use.net)
 * Created On:	December 11, 2002
 *
 * Defines some basic types used in the NIF file.
 *
 *=========================================================================*/
#ifndef __NIFTYPES_H
#define __NIFTYPES_H


/*===========================================================================
 *
 * Begin Required Includes
 *
 *=========================================================================*/
  #include "genfile.h"
/*===========================================================================
 *		End of Required Includes
 *=========================================================================*/


/*===========================================================================
 *
 * Begin Definitions
 *
 *=========================================================================*/

	/* Default record sizes in bytes */
  #define NIF_HEADER_NAMESIZE 0x28

 
	/* Used for the mod position methods */
  #define NIF_MODX 1
  #define NIF_MODY 2
  #define NIF_MODZ 4


/*===========================================================================
 *		End of Definitions
 *=========================================================================*/


/*===========================================================================
 *
 * Begin Type Definitions
 *
 *=========================================================================*/

	/* NIF file 3D coordinate */
  typedef struct {
    float X;
    float Y;
    float Z;
   } nifpos_t;

  typedef struct {
    float X;
    float Y;
    float Z;
    float W;
   } nifpos4_t;


	/* Color information */
  typedef struct {
    float R;
    float G;
    float B;
   } nifcolor3_t;

  typedef struct {
    float R;
    float G;
    float B;
    float A;
   } nifcolor4_t;

  typedef struct {
    float U;
    float V;
   } nifposuv_t;

/*===========================================================================
 *		End of Type Definitions
 *=========================================================================*/

#endif
/*===========================================================================
 *		End of File Niftypes.H
 *=========================================================================*/
