/*===========================================================================
 *
 * File:	NifUVController.CPP
 * Author:	Dave Humphrey (uesp@m0use.net)
 * Created On:	Tuesday, December 24, 2002
 *
 * Description
 *
 *=========================================================================*/

	/* Include Files */
#include "stdafx.h"
#include "NifUVController.h"


/*===========================================================================
 *
 * Begin Local Definitions
 *
 *=========================================================================*/
  DEFINE_FILE("NifUVController.cpp");
/*===========================================================================
 *		End of Local Definitions
 *=========================================================================*/


/*===========================================================================
 *
 * Class CNifUVController Constructor
 *
 *=========================================================================*/
CNifUVController::CNifUVController () {
  //DEFINE_FUNCTION("CNifUVController::CNifUVController()");
  
 }
/*===========================================================================
 *		End of Class CNifUVController Constructor
 *=========================================================================*/


/*===========================================================================
 *
 * Class CNifUVController Method - void Destroy (void);
 *
 *=========================================================================*/
void CNifUVController::Destroy (void) {
  //DEFINE_FUNCTION("CNifUVController::Destroy()");

  CNifBaseRecord::Destroy();
 }
/*===========================================================================
 *		End of Class Method CNifUVController::Destroy()
 *=========================================================================*/


/*===========================================================================
 *
 * Class CNifUVController Method - bool Read (FileHandle);
 *
 *=========================================================================*/
bool CNifUVController::Read (CGenFile& FileHandle) {
  //DEFINE_FUNCTION("CNifUVController::Read()");
  bool Result;

  Destroy();

  Result = FileHandle.ReadLong(m_Unknown1);
  if (Result) Result = FileHandle.ReadShort(m_Unknown2);
  if (Result) Result = FileHandle.Read((char *)&m_Floats[0], sizeof(float)*NIF_VISCON_NUMFLOATS);
  if (Result) Result = FileHandle.ReadLong(m_Unknown3);
  if (Result) Result = FileHandle.ReadLong(m_Unknown4);
  if (Result) Result = FileHandle.ReadShort(m_Unknown5);
  if (!Result) return (false);

  SetIsLoaded(true);
  return (true);
 }
/*===========================================================================
 *		End of Class Method CNifUVController::Read()
 *=========================================================================*/


/*===========================================================================
 *
 * Class CNifUVController Method - bool Read (FileHandle);
 *
 *=========================================================================*/
bool CNifUVController::Write (CGenFile& FileHandle) {
  //DEFINE_FUNCTION("CNifUVController::Write()");
  bool Result;

	/* Call the base class record method */
  Result = CNifBaseRecord::Write(FileHandle);
  if (!Result) return (false);

  Result = FileHandle.WriteLong(m_Unknown1);
  if (Result) Result = FileHandle.WriteShort(m_Unknown2);
  if (Result) Result = FileHandle.Write((char *)&m_Floats[0], sizeof(float)*NIF_VISCON_NUMFLOATS);
  if (Result) Result = FileHandle.WriteLong(m_Unknown3);
  if (Result) Result = FileHandle.WriteLong(m_Unknown4);
  if (Result) Result = FileHandle.WriteShort(m_Unknown5);
  if (!Result) return (false);

  return (true);
 }
/*===========================================================================
 *		End of Class Method CNifUVController::Write()
 *=========================================================================*/