/*===========================================================================
 *
 * File:	NifUVData.CPP
 * Author:	Dave Humphrey (uesp@m0use.net)
 * Created On:	Tuesday, December 24, 2002
 *
 * Description
 *
 *=========================================================================*/

	/* Include Files */
#include "stdafx.h"
#include "NifUVData.h"


/*===========================================================================
 *
 * Begin Local Definitions
 *
 *=========================================================================*/
  DEFINE_FILE("NifUVData.cpp");
/*===========================================================================
 *		End of Local Definitions
 *=========================================================================*/


/*===========================================================================
 *
 * Class CNifUVDataRecord Constructor
 *
 *=========================================================================*/
CNifUVDataRecord::CNifUVDataRecord () {
  //DEFINE_FUNCTION("CNifUVDataRecord::CNifUVDataRecord()");
  m_NumRecords = 0;
  m_pRecords = NULL;
 }
/*===========================================================================
 *		End of Class CNifUVDataRecord Constructor
 *=========================================================================*/


/*===========================================================================
 *
 * Class CNifUVDataRecord Method - void Destroy (void);
 *
 * Description
 *
 *=========================================================================*/
void CNifUVDataRecord::Destroy (void) {
  DEFINE_FUNCTION("CNifUVDataRecord::Destroy()");

  DestroyArrayPointer(m_pRecords);
  m_NumRecords = 0;
 }
/*===========================================================================
 *		End of Class Method CNifUVDataRecord::Destroy()
 *=========================================================================*/


/*===========================================================================
 *
 * Class CNifUVDataRecord Method - bool Read (FileHandle);
 *
 *=========================================================================*/
bool CNifUVDataRecord::Read (CGenFile& FileHandle) {
  DEFINE_FUNCTION("CNifUVData::ReadRecord()");
  bool Result;

  Destroy();

  Result = FileHandle.ReadLong(m_NumRecords);
  if (!Result) return (false);
  if (m_NumRecords == 0) return (true);

  CreateArrayPointer(m_pRecords, nifpos4_t, m_NumRecords);
  
  Result = FileHandle.ReadLong(m_Unknown1);
  if (Result) Result = FileHandle.Read((char *)m_pRecords, sizeof(nifpos4_t)*m_NumRecords);
  if (!Result) return (false);

  return (true);
 }
/*===========================================================================
 *		End of Class Method CNifUVDataRecord::Read()
 *=========================================================================*/


/*===========================================================================
 *
 * Class CNifUVDataRecord Method - bool Read (FileHandle);
 *
 *=========================================================================*/
bool CNifUVDataRecord::Write (CGenFile& FileHandle) {
  //DEFINE_FUNCTION("CNifUVDataRecord::Write()");
  bool Result;

  Result = FileHandle.WriteLong(m_NumRecords);
  if (!Result) return (false);
  if (m_NumRecords == 0) return (true);

  Result = FileHandle.WriteLong(m_Unknown1);
  if (Result) Result = FileHandle.Write((char *)m_pRecords, sizeof(nifpos4_t)*m_NumRecords);
  if (!Result) return (false);

  return (true);
 }
/*===========================================================================
 *		End of Class Method CNifUVDataRecord::Write()
 *=========================================================================*/


/*===========================================================================
 *
 * Class CNifUVData Constructor
 *
 *=========================================================================*/
CNifUVData::CNifUVData () {
  //DEFINE_FUNCTION("CNifUVData::CNifUVData()");
  
 }
/*===========================================================================
 *		End of Class CNifUVData Constructor
 *=========================================================================*/


/*===========================================================================
 *
 * Class CNifUVData Method - void Destroy (void);
 *
 *=========================================================================*/
void CNifUVData::Destroy (void) {
  //DEFINE_FUNCTION("CNifUVData::Destroy()");

  CNifBaseRecord::Destroy();
 }
/*===========================================================================
 *		End of Class Method CNifUVData::Destroy()
 *=========================================================================*/


/*===========================================================================
 *
 * Class CNifUVData Method - bool Read (FileHandle);
 *
 *=========================================================================*/
bool CNifUVData::Read (CGenFile& FileHandle) {
  //DEFINE_FUNCTION("CNifUVData::Read()");
  bool Result;

  Destroy();

  Result = m_Record1.Read(FileHandle);
  if (Result) Result = m_Record2.Read(FileHandle);
  if (Result) Result = m_Record3.Read(FileHandle);
  if (Result) Result = m_Record4.Read(FileHandle);
  if (!Result) return (false);

  SetIsLoaded(true);
  return (true);
 }
/*===========================================================================
 *		End of Class Method CNifUVData::Read()
 *=========================================================================*/


/*===========================================================================
 *
 * Class CNifUVData Method - bool Read (FileHandle);
 *
 *=========================================================================*/
bool CNifUVData::Write (CGenFile& FileHandle) {
  //DEFINE_FUNCTION("CNifUVData::Write()");
  bool Result;

	/* Call the base class record method */
  Result = CNifBaseRecord::Write(FileHandle);
  if (!Result) return (false);

  Result = m_Record1.Write(FileHandle);
  if (Result) Result = m_Record2.Write(FileHandle);
  if (Result) Result = m_Record3.Write(FileHandle);
  if (Result) Result = m_Record4.Write(FileHandle);
  if (!Result) return (false);

  return (true);
 }
/*===========================================================================
 *		End of Class Method CNifUVData::Write()
 *=========================================================================*/