/*===========================================================================
 *
 * File:	NifUVData.H
 * Author:	Dave Humphrey (uesp@m0use.net)
 * Created On:	Tuesday, December 24, 2002
 *
 * Description
 *
 *=========================================================================*/
#ifndef __NIFUVDATA_H
#define __NIFUVDATA_H


/*===========================================================================
 *
 * Begin Required Includes
 *
 *=========================================================================*/
  #include "NifBase.h"
/*===========================================================================
 *		End of Required Includes
 *=========================================================================*/


/*===========================================================================
 *
 * Begin Definitions
 *
 *=========================================================================*/
  #define NIF_UVDATA_NUMFLOATS 8
/*===========================================================================
 *		End of Definitions
 *=========================================================================*/


/*===========================================================================
 *
 * Begin Class CNifUVDataRecord Definition
 *
 * Description
 *
 *=========================================================================*/
class CNifUVDataRecord {

  /*---------- Begin Private Class Members ----------------------*/
private:
  long		m_NumRecords;
  long		m_Unknown1;
  nifpos4_t*	m_pRecords;


  /*---------- Begin Protected Class Methods --------------------*/
protected:


  /*---------- Begin Public Class Methods -----------------------*/
public:

	/* Class Constructors/Destructors */
  CNifUVDataRecord();
  virtual ~CNifUVDataRecord() { Destroy(); }
  virtual void Destroy (void);

	/* Input/Output the section from the current position in the file */
  virtual bool Read  (CGenFile& FileHandle);
  virtual bool Write (CGenFile& FileHandle);

 };
/*===========================================================================
 *		End of Class CNifUVDataRecord Definition
 *=========================================================================*/



/*===========================================================================
 *
 * Begin Class CNifUVData Definition
 *
 * Description
 *
 *=========================================================================*/
class CNifUVData : public CNifBaseRecord {

  /*---------- Begin Private Class Members ----------------------*/
private:
  CNifUVDataRecord	m_Record1;
  CNifUVDataRecord	m_Record2;
  CNifUVDataRecord	m_Record3;
  CNifUVDataRecord	m_Record4;
 

  /*---------- Begin Protected Class Methods --------------------*/
protected:


  /*---------- Begin Public Class Methods -----------------------*/
public:

	/* Class Constructors/Destructors */
  CNifUVData();
  virtual ~CNifUVData() { Destroy(); }
  virtual void Destroy (void);

	/* Input/Output the section from the current position in the file */
  virtual bool Read  (CGenFile& FileHandle);
  virtual bool Write (CGenFile& FileHandle);

 };
/*===========================================================================
 *		End of Class CNifUVData Definition
 *=========================================================================*/


#endif
/*===========================================================================
 *		End of File NifVisData.H
 *=========================================================================*/
