/*===========================================================================
 *
 * File:	Nifvertexcolorproperty.CPP
 * Author:	Dave Humphrey (uesp@m0use.net)
 * Created On:	Monday, December 23, 2002
 *
 * Description
 *
 *=========================================================================*/

	/* Include Files */
#include "stdafx.h"
#include "nifvertexcolorproperty.h"


/*===========================================================================
 *
 * Begin Local Definitions 
 *
 *=========================================================================*/
  DEFINE_FILE("NifVertexColorProperty.cpp");
/*===========================================================================
 *		End of Local Definitions
 *=========================================================================*/


/*===========================================================================
 *
 * Class CNifVertexColorProperty Constructor
 *
 *=========================================================================*/
CNifVertexColorProperty::CNifVertexColorProperty () {
  //DEFINE_FUNCTION("CNifVertexColorProperty::CNifVertexColorProperty()");

 }
/*===========================================================================
 *		End of Class CNifVertexColorProperty Constructor
 *=========================================================================*/


/*===========================================================================
 *
 * Class CNifVertexColorProperty Method - void Destroy (void);
 *
 * Description
 *
 *=========================================================================*/
void CNifVertexColorProperty::Destroy (void) {
  //DEFINE_FUNCTION("CNifVertexColorProperty::Destroy()");
 
  CNifBaseRecord::Destroy();
 }
/*===========================================================================
 *		End of Class Method CNifVertexColorProperty::Destroy()
 *=========================================================================*/


/*===========================================================================
 *
 * Class CNifVertexColorProperty Method - bool Read (FileHandle);
 *
 * Input the node data from the current position in the given file.  Assumes
 * that the current position in the file is the byte after the last character
 * in the "NifNode" name record header.  Returns false on any error.
 *
 *=========================================================================*/
bool CNifVertexColorProperty::Read (CGenFile& FileHandle) {
  bool Result;
  
	/* Delete the current record contents */ 
  Destroy();
  
	/* Input first three numbers */
  Result = FileHandle.ReadLong(m_Unknown1);
  if (Result) Result = FileHandle.ReadLong(m_Unknown2);
  if (Result) Result = FileHandle.ReadLong(m_Unknown3);
  if (Result) Result = FileHandle.ReadLong(m_Unknown4);
  if (Result) Result = FileHandle.ReadShort(m_Unknown5);
  if (Result) Result = FileHandle.ReadLong(m_Unknown6);
  if (!Result) return (false);

	/* Return success */
  SetIsLoaded(true);
  return (true);
 }
/*===========================================================================
 *		End of Class Method CNiCNifVertexColorPropertyfEndFile::Read()
 *=========================================================================*/
  

/*===========================================================================
 *
 * Class CNifEndFile Method - bool Write (FileHandle);
 *
 * Input the node data to the current position in the given file.  Outputs the
 * record header and data.  Returns false on any error.
 *
 *=========================================================================*/
bool CNifVertexColorProperty::Write (CGenFile& FileHandle) {
  bool Result;

	/* Call the base class method first */
  Result = CNifBaseRecord::Write(FileHandle);
  if (!Result) return (false);

  Result = FileHandle.WriteLong(m_Unknown1);
  if (Result) Result = FileHandle.WriteLong(m_Unknown2);
  if (Result) Result = FileHandle.WriteLong(m_Unknown3);
  if (Result) Result = FileHandle.WriteLong(m_Unknown4);
  if (Result) Result = FileHandle.WriteShort(m_Unknown5);
  if (Result) Result = FileHandle.WriteLong(m_Unknown6);
  if (!Result) return (false);

	/* Return success */
  return (true);
 }
/*===========================================================================
 *		End of Class Method CNifVertexColorProperty::Write()
 *=========================================================================*/



 