/*===========================================================================
 *
 * File:	NifVisData.CPP
 * Author:	Dave Humphrey (uesp@m0use.net)
 * Created On:	Tuesday, December 24, 2002
 *
 * Description
 *
 *=========================================================================*/

	/* Include Files */
#include "stdafx.h"
#include "NifVisData.h"


/*===========================================================================
 *
 * Begin Local Definitions
 *
 *=========================================================================*/
  DEFINE_FILE("NifVisData.cpp");
/*===========================================================================
 *		End of Local Definitions
 *=========================================================================*/


/*===========================================================================
 *
 * Class CNifVisData Constructor
 *
 *=========================================================================*/
CNifVisData::CNifVisData () {
  //DEFINE_FUNCTION("CNifVisData::CNifVisData()");
  m_pData = NULL;
  m_NumRecords = 0;
 }
/*===========================================================================
 *		End of Class CNifVisData Constructor
 *=========================================================================*/


/*===========================================================================
 *
 * Class CNifVisData Method - void Destroy (void);
 *
 *=========================================================================*/
void CNifVisData::Destroy (void) {
  DEFINE_FUNCTION("CNifVisData::Destroy()");
  
  m_NumRecords = 0;
  DestroyArrayPointer(m_pData);

  CNifBaseRecord::Destroy();
 }
/*===========================================================================
 *		End of Class Method CNifVisData::Destroy()
 *=========================================================================*/


/*===========================================================================
 *
 * Class CNifVisData Method - bool Read (FileHandle);
 *
 *=========================================================================*/
bool CNifVisData::Read (CGenFile& FileHandle) {
  DEFINE_FUNCTION("CNifVisData::Read()");
  bool Result;

  Destroy();

  Result = FileHandle.ReadLong(m_NumRecords);
  if (!Result) return (false);

  if (m_NumRecords > 0) {
    CreateArrayPointer(m_pData, nifvisdatarecord_t, m_NumRecords);
    Result = FileHandle.Read((char *)&m_pData[0], sizeof(nifvisdatarecord_t)*m_NumRecords);
    if (!Result) return (false);
   }

  SetIsLoaded(true);
  return (true);
 }
/*===========================================================================
 *		End of Class Method CNifVisData::Read()
 *=========================================================================*/


/*===========================================================================
 *
 * Class CNifVisData Method - bool Read (FileHandle);
 *
 *=========================================================================*/
bool CNifVisData::Write (CGenFile& FileHandle) {
  //DEFINE_FUNCTION("CNifVisData::Write()");
  bool Result;

	/* Call the base class record method */
  Result = CNifBaseRecord::Write(FileHandle);
  if (!Result) return (false);

  Result = FileHandle.WriteLong(m_NumRecords);
  if (!Result) return (false);

  if (m_NumRecords > 0) {
    Result = FileHandle.Write((char *)&m_pData[0], sizeof(nifvisdatarecord_t)*m_NumRecords);
    if (!Result) return (false);
   }

  return (true);
 }
/*===========================================================================
 *		End of Class Method CNifVisData::Write()
 *=========================================================================*/