/*===========================================================================
 *
 * File:	NifVisData.H
 * Author:	Dave Humphrey (uesp@m0use.net)
 * Created On:	Tuesday, December 24, 2002
 *
 * Description
 *
 *=========================================================================*/
#ifndef __NIFVISDATA_H
#define __NIFVISDATA_H


/*===========================================================================
 *
 * Begin Required Includes
 *
 *=========================================================================*/
  #include "NifBase.h"
/*===========================================================================
 *		End of Required Includes
 *=========================================================================*/


/*===========================================================================
 *
 * Begin Definitions
 *
 *=========================================================================*/
  #define NIF_VISDATA_NUMBYTES 19
/*===========================================================================
 *		End of Definitions
 *=========================================================================*/



/*===========================================================================
 *
 * Begin Type Definitions
 *
 *=========================================================================*/
#pragma pack(push, 1)

  typedef struct {
    char Data[5];
   } nifvisdatarecord_t;

#pragma pack(pop)
/*===========================================================================
 *		End of Type Definitions
 *=========================================================================*/


/*===========================================================================
 *
 * Begin Class CNifVisData Definition
 *
 * Description
 *
 *=========================================================================*/
class CNifVisData : public CNifBaseRecord {

  /*---------- Begin Private Class Members ----------------------*/
private:
  long			m_NumRecords;
  nifvisdatarecord_t*	m_pData;


  /*---------- Begin Protected Class Methods --------------------*/
protected:


  /*---------- Begin Public Class Methods -----------------------*/
public:

	/* Class Constructors/Destructors */
  CNifVisData();
  virtual ~CNifVisData() { Destroy(); }
  virtual void Destroy (void);

	/* Input/Output the section from the current position in the file */
  virtual bool Read  (CGenFile& FileHandle);
  virtual bool Write (CGenFile& FileHandle);

 };
/*===========================================================================
 *		End of Class CNifVisData Definition
 *=========================================================================*/


#endif
/*===========================================================================
 *		End of File NifVisData.H
 *=========================================================================*/
