/*===========================================================================
 *
 * File:	NifWireframeProperty.CPP
 * Author:	Dave Humphrey (uesp@m0use.net)
 * Created On:	December 11, 2002
 *
 * Description
 *
 *=========================================================================*/

	/* Include Files */
#include "stdafx.h"
#include "NifWireframeProperty.h"


/*===========================================================================
 *
 * Begin Local Definitions
 *
 *=========================================================================*/
  DEFINE_FILE("NifWireframeProperty.cpp");
/*===========================================================================
 *		End of Local Definitions
 *=========================================================================*/


/*===========================================================================
 *
 * Class CNifWireframeProperty Constructor
 *
 *=========================================================================*/
CNifWireframeProperty::CNifWireframeProperty () {
  //DEFINE_FUNCTION("CNifWireframeProperty::CNifWireframeProperty()");
  m_PropertyName = _T(""); 
 }
/*===========================================================================
 *		End of Class CNifWireframeProperty Constructor
 *=========================================================================*/


/*===========================================================================
 *
 * Class CNifWireframeProperty Method - void Destroy (void);
 *
 *=========================================================================*/
void CNifWireframeProperty::Destroy (void) {
  //DEFINE_FUNCTION("CNifWireframeProperty::Destroy()");
  m_PropertyName = _T("");

	/* Call the base class method */
  CNifBaseRecord::Destroy();
 }
/*===========================================================================
 *		End of Class Method CNifWireframeProperty::Destroy()
 *=========================================================================*/


/*===========================================================================
 *
 * Class CNifWireframeProperty Method - bool Read (FileHandle);
 *
 * Input the node data from the current position in the given file.  Assumes
 * that the current position in the file is the byte after the last character
 * in the "NifNode" name record header.  Returns false on any error.
 *
 *=========================================================================*/
bool CNifWireframeProperty::Read (CGenFile& FileHandle) {
  bool Result;
  
	/* Delete the current record contents */ 
  Destroy();

	/* Input the optional texture string name */
  Result = NifReadString(FileHandle, m_PropertyName);
  if (!Result) return (false);
  
	/* Input first three numbers */
  Result = FileHandle.ReadLong(m_Unknown1);
  if (Result) Result = FileHandle.ReadLong(m_Unknown2);
  if (Result) Result = FileHandle.ReadShort(m_Unknown3);
  if (!Result) return (false);

	/* Return success */
  SetIsLoaded(true);
  return (true);
 }
/*===========================================================================
 *		End of Class Method CNifWireframeProperty::Read()
 *=========================================================================*/
  

/*===========================================================================
 *
 * Class CNifWireframeProperty Method - bool Write (FileHandle);
 *
 * Input the node data to the current position in the given file.  Outputs the
 * record header and data.  Returns false on any error.
 *
 *=========================================================================*/
bool CNifWireframeProperty::Write (CGenFile& FileHandle) {
  bool Result;

	/* Call the base class method first */
  Result = CNifBaseRecord::Write(FileHandle);
  if (!Result) return (false);

	/* Output the optional texture string name */
  Result = NifWriteString(FileHandle, m_PropertyName);
  if (!Result) return (false);
  
	/* Output first three numbers */
  Result = FileHandle.WriteLong(m_Unknown1);
  if (Result) Result = FileHandle.WriteLong(m_Unknown2);
  if (Result) Result = FileHandle.WriteShort(m_Unknown3);
  if (!Result) return (false);

	/* Return success */
  return (true);
 }
/*===========================================================================
 *		End of Class Method CNifWireframeProperty::Write()
 *=========================================================================*/
