/*===========================================================================
 *
 * File:	Mwesm_tes3.H
 * Author:	Dave Humphrey (uesp@m0use.net)
 * Created On:	Wednesday, September 04, 2002
 *
 * Defines the CMwEsmRecordTES3 class.
 *
 *=========================================================================*/
#ifndef __MWESM_TES3_H
#define __MWESM_TES3_H


/*===========================================================================
 *
 * Begin Required Includes
 *
 *=========================================================================*/
  #include "mwesm_baserec.h"
/*===========================================================================
 *		End of Required Includes
 *=========================================================================*/


/*===========================================================================
 *
 * Begin Class CMwEsmRecordTES3 Definition
 *
 * Defines the TES3 ESM base record class.
 *
 Sub-Section HEDR (300 bytes)
		4 bytes, float Version (1.2)
		4 bytes, long Unknown (1)
		32 Bytes, Company Name string
		256 Bytes, ESM file description?
		4 bytes, long Unknown (48227)
 *
 *=========================================================================*/
class CMwEsmRecordTES3 : public CMwEsmBaseRecord {

  /*---------- Begin Private Class Members ----------------------*/
private:


  /*---------- Begin Protected Class Methods --------------------*/
protected:


  /*---------- Begin Public Class Methods -----------------------*/
public:

	/* Class Constructors/Destructors */
  CMwEsmRecordTES3();
  virtual ~CMwEsmRecordTES3() { Destroy(); }
  virtual void Destroy (void);

	/* Get class members */
  virtual bool IsBaseRecord	(void) const { return (false); }

 };
/*===========================================================================
 *		End of Class CMwEsmRecordTES3 Definition
 *=========================================================================*/


#endif
/*===========================================================================
 *		End of File Mwesm_tes3.H
 *=========================================================================*/

