/*===========================================================================
 *
 * File:	Genxaxis.H
 * Author:	Dave Humphrey (uesp@m0use.net)
 * Created On:	Thursday, October 17, 2002
 *
 * Description
 *
 *=========================================================================*/
#ifndef __GENXAXIS_H
#define __GENXAXIS_H


/*===========================================================================
 *
 * Begin Required Includes
 *
 *=========================================================================*/
  #include "GenGAxis.h"
/*===========================================================================
 *		End of Required Includes
 *=========================================================================*/


/*===========================================================================
 *
 * Begin Class CGenXAxis Definition
 *
 * Description
 *
 *=========================================================================*/
class CGenXAxis : public virtual CGenGraphAxis {

  /*---------- Begin Private Class Members ----------------------*/
private:


  /*---------- Begin Protected Class Methods --------------------*/
protected:

	/* Helper draw functions */
  virtual int DrawAxis  (CDC* pDC);
  virtual int DrawLabel (CDC* pDC);
  virtual int DrawTicks (CDC* pDC);


  /*---------- Begin Public Class Methods -----------------------*/
public:

	/* Class Constructors/Destructors */
  //CGenXAxis();
  //virtual ~CGenXAxis() { Destroy(); }
  //virtual void Destroy (void);


	/* Get class members */
  virtual int  GetAxisLength	(void) const { return (GetWidth()); }
  virtual int  GetAxisOrigin	(void) const { return (GetLeft()); }
  virtual bool IsXAxis		(void) const { return (true); }

  int LimitCoorToLogical (const graphdata_t Value) const {
    int Log = FastCoorToLogical(Value);

    if (Log <= m_Left) 
      return (m_Left + 1);
    else if (Log >= m_Right) 
      return (m_Right - 1);
    else
      return (Log);
   }


 };
/*===========================================================================
 *		End of Class CGenXAxis Definition
 *=========================================================================*/



#endif
/*===========================================================================
 *		End of File Genxaxis.H
 *=========================================================================*/
