/*===========================================================================
 *
 * File:	Genyaxis.H
 * Author:	Dave Humphrey (uesp@m0use.net)
 * Created On:	Thursday, October 17, 2002
 *
 * Description
 *
 *=========================================================================*/
#ifndef __GENYAXIS_H
#define __GENYAXIS_H


/*===========================================================================
 *
 * Begin Required Includes
 *
 *=========================================================================*/
  #include "GenGAxis.h"
/*===========================================================================
 *		End of Required Includes
 *=========================================================================*/


/*===========================================================================
 *
 * Begin Class CGenYAxis Definition
 *
 * Description
 *
 *=========================================================================*/
class CGenYAxis : public virtual CGenGraphAxis {

  /*---------- Begin Private Class Members ----------------------*/
private:


  /*---------- Begin Protected Class Methods --------------------*/
protected:

	/* Helper draw functions */
  virtual int DrawAxis  (CDC* pDC);
  virtual int DrawLabel (CDC* pDC);
  virtual int DrawTicks (CDC* pDC);


  /*---------- Begin Public Class Methods -----------------------*/
public:

	/* Class Constructors/Destructors */
  //CGenYAxis();
  //virtual ~CGenYAxis() { Destroy(); }
  //virtual void Destroy (void);


	/* Get class members */
  virtual int  GetAxisLength	(void) const { return (GetHeight()); }
  virtual int  GetAxisOrigin	(void) const { return (GetBottom()); }
  virtual bool IsYAxis		(void) const { return (true); }

  int LimitCoorToLogical (const graphdata_t Value) const {
    int Log = FastCoorToLogical(Value);

    if (Log <= m_Top) 
      return (m_Top + 1);
    else if (Log >= m_Bottom) 
      return (m_Bottom - 1);
    else
      return (Log);
   }

 };
/*===========================================================================
 *		End of Class CGenYAxis Definition
 *=========================================================================*/



#endif
/*===========================================================================
 *		End of File Genyaxis.H
 *=========================================================================*/
